// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Gasdynamics.h"
#include "MainFrm.h"
#include "Proc2D.h"
#include "Proc3D.h"
#include "ProcStereo.h"
#include "SheetDialog.h"
#include "Data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//-------------------------
	extern BOOL bRepaint;
	extern CString methodTitle;
	extern METHOD_TYPE eMethodType;

	extern int	mNx,mNy; //  
	extern int		mask[NX_MAX][NY_MAX];
	extern double	matrix[NF][NX_MAX][NY_MAX];

				//	244*84
	extern double U1[4][NX_MAX][NY_MAX];
	extern double V[4][NX_MAX];
	extern double F[4][NX_MAX],P[NX_MAX];
	extern double D[4][NX_MAX],Dg[4][NX_MAX],A[4][NX_MAX],B[4][NX_MAX],R[4][4][NX_MAX];
	extern double Vgas[4];
	extern double Hx,Hy,Hmin,CFL;
	extern double G,G0,G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,G12;
	extern double U0,P0,R0,E0,Ce,Uchap,Utest,Ptest,Rtest,Etest;
	extern double Time, Lx,Ly,Lt,Lt0;
	extern int Nx,Ny,Mx,My,Jt,Nout, KeyOut;
	extern int Nx_,Ny_,Mx_,My_,iOut;

//-------------------------
	extern int	m_NClr;
	extern int	Nc;
	extern double	m_Range[NF][2];

	extern	Proc2D* p2D[NF];
	extern	Proc3D* p3D[NF];
	extern	ProcStereo* pStereo[NF];

	extern	enum JC_GAS Jc_Wnd;

	const double M_PI_180 = M_PI/180.;

//-------------------------

// m_hRunRequest:    ""-   Data  
HANDLE	CMainFrame::m_hRunRequest      =CreateEvent(NULL, TRUE, FALSE, NULL);
HANDLE	CMainFrame::m_hEventNeedNotDC = CreateEvent(NULL, TRUE, FALSE, NULL);

extern BOOL bRunRequest, bInitCalculations, bRepaint;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_COMMAND(ID_BUTTON_GO,	OnButtonGo)
	ON_COMMAND(ID_BUTTON_PAUSE, OnButtonPause)
	ON_COMMAND(ID_BUTTON_INIT,	OnButtonInit)
	ON_COMMAND(ID_BUTTON_R,		OnButtonR)
	ON_COMMAND(ID_BUTTON_P,		OnButtonP)
	ON_COMMAND(ID_BUTTON_E,		OnButtonE)
	ON_COMMAND(ID_BUTTON_M,		OnButtonM)
	ON_COMMAND(ID_BUTTON_H,		OnButtonH)
	ON_COMMAND(ID_BUTTON_S,		OnButtonS)
	ON_COMMAND(ID_BUTTON_U,		OnButtonU)
	ON_COMMAND(ID_BUTTON_UX,	OnButtonUx)
	ON_COMMAND(ID_BUTTON_UY,	OnButtonUy)
	ON_COMMAND(ID_BUTTON_2D,	OnButton2D)
	ON_COMMAND(ID_BUTTON_3D,	OnButton3D)
	ON_COMMAND(ID_BUTTON_STEREO,OnButtonStereo)
	ON_COMMAND(ID_BUTTON_COLOR, OnButtonColor)
	ON_COMMAND(ID_BUTTON_INC, OnButtonInc)
	ON_COMMAND(ID_BUTTON_DEC, OnButtonDec)
	ON_COMMAND(ID_BUTTON_UP,	OnButtonUp)
	ON_COMMAND(ID_BUTTON_DOWN,	OnButtonDown)
	ON_COMMAND(ID_BUTTON_LEFT,	OnButtonLeft)
	ON_COMMAND(ID_BUTTON_RIGHT, OnButtonRight)
	ON_COMMAND(ID_BUTTON_PAINT, OnButtonPaint)
	ON_COMMAND(ID_BUTTON_TOOLS, OnButtonTools)
	ON_MESSAGE(PM_TITLE, OnTitle)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	int k,x;

	pData = NULL;
	pSheetDialog = NULL;

	for (k=0; k<NF; k++)
	{
		p2D[k] = NULL;
		p3D[k] = NULL;
		pStereo[k] = NULL;
	}

	be = 200;
	al = 35;

	dwColor[0] = RGB(0,0,0);		//  
	dwColor[1] = RGB(200,0,0);		//    
	dwColor[2] = RGB(0,150,0);		//  X=0, Y=0
	dwColor[3] = RGB(100,200,255);	//  

	bFirstRun = TRUE;
	bExecuteOnButtonPaint = FALSE;
	bMainFirst = TRUE;
	bTitle = FALSE;
	bRotate = FALSE;
	bRepaint = TRUE;

	m_NClr = 0;
	Nc = 16;

	nType = SW_SHOWNORMAL;
	Scale3D = 0.6;
	ScaleStereo = 0.7;
	baza = 80;

	rectDefault.left = 50;
	rectDefault.top = 10;
	rectDefault.right = 450;
	rectDefault.bottom = 310;
// - - - - - - - - - - - - - -

	eMethodType = MT_LW;
	methodTitle.LoadString(IDS_STRING_LW);

	Lx = 3.; Nx = 240; Mx = 48; Lt = 4.;    Nout = 80;
	Ly = 1.; Ny = 80;  My = 16; CFL = 0.8;  Ce = 1.;

	G = 7./5.;
	U0 = 3.;
	P0 = 1.;
	R0 = G;

	for (x=0; x<NX_MAX; x++)
	{
		for (k=0; k<=2; k++)	R[0][k][x] = 1.;
		R[0][3][x] = 0.;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::InitCalculations()
{
	int k,x,y;

	G0 = (G + 1.)*2.;
	G1 = G - 1.;
	G2 = (G - 1.)/2.;
	G3 = (3. - G)/2.;
	G4 = (G + 1.)/2.;
	G5 = (G - 1.)/(2.*G);
	G6 = (G - 1.)/(G + 1.);
	G7 = (3.*G - 1.)/(G + 1.);
	G8 = -(G + 1.)/(2.*G);
	G9 = (G - 1.)*2.;
	G10 = G/(G - 1.);
	G11 = 1./(G - 1.);
	G12 = G*(G - 1.);

	E0 = P0/(R0*G1);

	Utest = U0;
		Ptest = U0*R0*G0;
	Ptest = P0 + ((G + 1.)*R0*U0/2. + sqrt(Ptest*Ptest + (5.*G + 3.)*P0*R0/2.))*U0/2.;
	Rtest = R0*(G1*P0 + (G + 1.)*Ptest)/((G + 1.)*P0 + G1*Ptest);
	Etest = Ptest/(Rtest*G1);

	Time = 0.;
	Lt0 = 0.;
	Jt = 0;
	iOut = 1;

	Vgas[0] = R0;
	Vgas[1] = R0*U0;
	Vgas[2] = 0.;
	Vgas[3] = R0*(E0 + U0*U0*0.5);


	mNx = Nx + 3;	mNy = Ny + 3;
	Nx_ = Nx + 1;	Ny_ = Ny + 1;
	Mx_ = Mx + 1;	My_ = My + 1;

	Hx = Lx/Nx;	Hy = Ly/Ny;

	Hmin = __min(Hx,Hy);

	for (y=0; y<=mNy; y++)
	for (x=0; x<=mNx; x++)
	for (k=0; k<=3; k++)	U1[k][x][y] = Vgas[k];

	for (y=mNy; y>=0;	y--)
	for (x=0;	x<=mNx; x++)
	if (IsInGas(x,y))	mask[x][y] = 1;
	else				mask[x][y] = 0;
}
//---------------------------------------------------------------------------
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	// be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

//---------   go,pause -----
//	       
//	      
	int n = m_wndToolBar.CommandToIndex(ID_BUTTON_GO);
	m_wndToolBar.SetButtonStyle(n,TBBS_CHECKGROUP|TBBS_CHECKBOX);

	//  "go"   
	(m_wndToolBar.GetToolBarCtrl()).CheckButton(ID_BUTTON_GO, TRUE);

	n = m_wndToolBar.CommandToIndex(ID_BUTTON_PAUSE);
	m_wndToolBar.SetButtonStyle(n,TBBS_CHECKGROUP|TBBS_CHECKBOX);

	n = m_wndToolBar.CommandToIndex(ID_BUTTON_INIT);
//	m_wndToolBar.SetButtonStyle(n,TBBS_CHECKGROUP|TBBS_CHECKBOX);

//---------   2D,3D,stereo -----
//	       
//	      

	n = m_wndToolBar.CommandToIndex(ID_BUTTON_2D);
	m_wndToolBar.SetButtonStyle(n,TBBS_CHECKGROUP|TBBS_CHECKBOX);

	n = m_wndToolBar.CommandToIndex(ID_BUTTON_3D);
	m_wndToolBar.SetButtonStyle(n,TBBS_CHECKGROUP|TBBS_CHECKBOX);

	//  "2D"   
	(m_wndToolBar.GetToolBarCtrl()).CheckButton(ID_BUTTON_2D, TRUE);

	n2D3DS_create = 2;
	n3DS_rotate = n2D3DS_create;

	n = m_wndToolBar.CommandToIndex(ID_BUTTON_STEREO);
	m_wndToolBar.SetButtonStyle(n,TBBS_CHECKGROUP|TBBS_CHECKBOX);

//-------   "color"   -------
	n = m_wndToolBar.CommandToIndex(ID_BUTTON_COLOR);
	m_wndToolBar.SetButtonStyle(n,TBBS_CHECKBOX);

	//  "color"   
	(m_wndToolBar.GetToolBarCtrl()).CheckButton(ID_BUTTON_COLOR, TRUE);

	return 0;
}
//---------------------------------------------------------------------------
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style &= ~FWS_ADDTOTITLE;

	return CMDIFrameWnd::PreCreateWindow(cs);
}
/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

//---------------------------------------------------------------------------
void CMainFrame::CheckWindow(enum JC_GAS Jg, int n_create, BOOL b)
{
//
// 1) ,    ,   -  
// 2)         b
//	
// Jg       -  .   
// n_create -   (1D, 2D, 3D, stereo)
// b        -  /
	UINT stringID;

	switch (Jg)
	{
		case Jg_R:	stringID = IDS_CAPTION_R; break;
		case Jg_P:	stringID = IDS_CAPTION_P; break;
		case Jg_E:	stringID = IDS_CAPTION_E; break;
		case Jg_M:	stringID = IDS_CAPTION_M; break;
		case Jg_H:	stringID = IDS_CAPTION_H; break;
		case Jg_S:	stringID = IDS_CAPTION_S; break;
		case Jg_U:	stringID = IDS_CAPTION_U; break;
		case Jg_Ux:	stringID = IDS_CAPTION_UX; break;
		case Jg_Uy:	stringID = IDS_CAPTION_UY; break;
	}

	switch (n_create)
	{
	case 2:
		{
			if (p2D[Jg] == NULL)
			{
				CString s;
				s.LoadString(stringID);

				(Proc2D*) p2D[Jg] = new Proc2D;

				LONG style = WS_CHILD | WS_VISIBLE | WS_OVERLAPPEDWINDOW;
				if (nType == SW_SHOWMAXIMIZED) style |= WS_MAXIMIZE;

				if (!p2D[Jg]->Create(_T(s), style, rectDefault, this, Jg) )
				{
					AfxMessageBox(_T("!p2D[Jg]->Create"));
					return;
				}
			}
	#ifdef _DEBUG
			if (((Proc2D*) p2D[Jg])->m_dc == NULL)
			{
				AfxMessageBox(_T("CMainFrame::CheckWindow2D\n((Proc2D*) p2D[Jg])->m_dc==NULL"));
				return;
			}
	#endif
			if (b)	((Proc2D*) p2D[Jg])->PicBox();
		}	break;
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	case 3:
		{
			if(p3D[Jg] == NULL)
			{
				CString s;
				s.LoadString(stringID);
				(Proc3D*) p3D[Jg] = new Proc3D;

			LONG style = WS_CHILD | WS_VISIBLE | WS_OVERLAPPEDWINDOW;
				if (nType == SW_SHOWMAXIMIZED) style |= WS_MAXIMIZE;

				if (!p3D[Jg]->Create(_T(s),	style, rectDefault, this, Jg) )
				{
					AfxMessageBox(_T("!p3D[Jg]->Create"));
					return;
				}
			}
	#ifdef _DEBUG
			if (((Proc3D*) p3D[Jg])->m_dc == NULL)
			{
				AfxMessageBox(_T("CMainFrame::CheckWindow3D\n((Proc3D*) p3D[Jg])->m_dc==NULL"));
				return;
			}
	#endif
			if (b)	((Proc3D*) p3D[Jg])->PicBox();
		}	break;
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	case 4:
		{
			if(pStereo[Jg] == NULL)
			{
				CString s;
				s.LoadString(stringID);
				(ProcStereo*) pStereo[Jg] = new ProcStereo;

				LONG style = WS_CHILD | WS_VISIBLE | WS_OVERLAPPEDWINDOW | WS_HSCROLL;
				if (nType == SW_SHOWMAXIMIZED) style |= WS_MAXIMIZE;

				if (!pStereo[Jg]->Create(_T(s),	style, rectDefault, this, Jg))
				{
					AfxMessageBox(_T("!pStereo[Jg]->Create"));
					return;
				}
			}
			if (b) ((ProcStereo*) pStereo[Jg])->PicBox();
		}	break;
	}
}
/////////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------
void CMainFrame::SetIsolLevels()
{
//         Jc_Levels 

	double	Otest;
	double	max,min;

	Jc_Levels.SetSize(Nc+1);

	m_Sdegree = 1;

	for(int Jg=0; Jg<NF; Jg++)
	{
		max = -DBL_MAX;
		min = DBL_MAX;

		for (int Jy=0; Jy<=mNy; Jy++)
		for (int Jx=0; Jx<=mNx; Jx++)
		{
			Otest = matrix[Jg][Jx][Jy];
			max = __max(max, Otest);
			min = __min(min, Otest);
		}

		m_Range[Jg][0] = min;
		m_Range[Jg][1] = max;

		for(int L = 0; L<Nc; L++)
		{
			double	Oa = L;
			Oa = Oa/(Nc - 1.);
			Jc_Levels[L].Levels[Jg] = (max - min)*pow(Oa, m_Sdegree) + min;
		}
	}
}
//---------------------------------------------------------------------------
void CMainFrame::UpdateTitle()
{
TRACE0("\nCMainFrame::UpdateTitle() beg");

	CString strCaption, s;

	s.LoadString(IDS_CAPTION_GO);
	strCaption.Format(s, Jt, Time, Lt);

	s = "[" + methodTitle + "] ";
	strCaption = s + strCaption;

TRACE0("\nCMainFrame::UpdateTitle()  SetWindowText(strCaption)");
	SetWindowText(strCaption);
TRACE0("\nCMainFrame::UpdateTitle()  end");
}
//---------------------------------------------------------------------------
BOOL CMainFrame::IsolSingle(CDC* m_dc, double dXmin,  double dXmax,
									   double dYmin,  double dYmax,
									   double y00, double y01,
									   double y10, double y11,
									   BOOL empty, enum JC_GAS Jg,
									   int size_cy)
{
//       

int		M,Ix,Iy,Ixmin,Ixmax,Iymin,Iymax,color; 
double	Z,Zmin,Zmax,dX,dY,Z1,Z2;

	CBrush whitebrush;
	CRect rect;

	whitebrush.CreateSolidBrush(RGB(255,255,255));

	Iymax = (int)dYmax; Iymin = (int)dYmin;
	Ixmax = (int)dXmax; Ixmin = (int)dXmin;

	if ( (Ixmax>=Ixmin) && (Iymax>=Iymin) ) 
	{
		rect.left = Ixmin;
		rect.right = Ixmax;
		rect.bottom = size_cy - Iymin;
		rect.top = size_cy - Iymax;
		
		if (empty)
		{
			m_dc->FillRect(rect, &whitebrush);
			goto Mend;
		}
		else
		{
			Z = (y10 + y00 + y01 + y11)/4.;

			color = Nc;
			for(M=0 ;M<Nc; M++)
			{
				if( Z<=GetLevels(M,Jg) ) { color=M; break; }
			}
			m_dc->FillRect(rect, pBrush[color]);
		}
	}

	for (Iy=Iymin; Iy<=Iymax; Iy++) 
	{
	 dY = (Iy - dYmin)/(dYmax - dYmin);
	 Z1 = y10*dY + y00*(1 - dY);
	 Z2 = y11*dY + y01*(1 - dY);
	 if ( Z1 != Z2 ) 
	 {
		 if( Z2>Z1  ) { Zmax = Z2; Zmin = Z1; }
		 else         { Zmax = Z1; Zmin = Z2; }
		 for(M=0; M<Nc; M++)
		 {
			Z = GetLevels(M,Jg);
			if(Zmin <= Z)
			{ 
				if (Zmax<Z) break;
				dX = (Z-Z1)/(Z2-Z1);
				Ix = (int)(dX*(dXmax - dXmin) + dXmin);
				m_dc->SetPixelV(Ix, size_cy - Iy,0);
			}
		} 
	 }
  }
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
  for(Ix=Ixmin; Ix<=Ixmax; Ix++) 
  {
	  dX = (Ix - dXmin)/(dXmax - dXmin);
	  Z1 = y01*dX + y00*(1 - dX);
	  Z2 = y11*dX + y10*(1 - dX);
	  if( Z1 != Z2 ) 
	  {
		  if( Z2>Z1  ) { Zmax = Z2;	Zmin = Z1; }
		  else         { Zmax = Z1;	Zmin = Z2; }
          for(M=0; M<Nc; M++)
		  {
			  Z = GetLevels(M,Jg);
			  if (Zmin <= Z)
			  {   
				  if (Zmax < Z) break;
				  dY = (Z-Z1)/(Z2-Z1);
	              Iy = (int)(dY*(dYmax-dYmin) + dYmin);
	              m_dc->SetPixelV(Ix, size_cy - Iy, 0);
			  }
		  }
	  }
  }
Mend:;	 whitebrush.DeleteObject();
  return TRUE;
}

//---------------------------------------------------------------------------
void CMainFrame::Isoline(CDC* m_dc, CRect* rcClient,enum JC_GAS Jg, SIZE size)
{
//   IsolSingle      
// (IsolSingle    ,  Isoline,  IsolSingle,
//     )

	double	y1,y0;
	int		Jx,Jy;
	BOOL	empty;
	double min, max;

	if (m_dc)
	{
		SIZE size;
		size = rcClient->Size();
		//----------------
		min = m_Range[Jg][0];
		max = m_Range[Jg][1];

		double cHx = ((double)size.cx)/(mNx-1);
		double cHy = ((double)size.cy)/(mNy-1);

		if (cHx > cHy)	cHx = cHy;
		else			cHy = cHx;

		CArray<double,double> cY;
		cY.SetSize(mNx+1);

		for(Jx=0; Jx<=mNx; Jx++)	cY[Jx] = matrix[Jg][Jx][0];
		

		for(Jy=0; Jy<=mNy-1; Jy++)
		{
			y0 = matrix[Jg][0][Jy+1];
			for(Jx=0; Jx<mNx; Jx++)
			{
				//----- checking for empty cells -----
				int ix0 = Jx;	
				int ix1 = Jx + 1;
				int iy0 = Jy;
				int iy1 = Jy + 1;

				if ( mask[ix0][iy0] && mask[ix0][iy1] && mask[ix1][iy0] && mask[ix1][iy1] )
					 empty = FALSE;
				else empty = TRUE;
				//----- end of checking -----

				y1 = matrix[Jg][Jx+1][Jy+1];

				IsolSingle(m_dc,Jx*cHx, (Jx+1)*cHx,
								Jy*cHy, (Jy+1)*cHy,
								cY[Jx], cY[Jx+1],
								y0,		y1,
								empty,  Jg,	size.cy);

				cY[Jx] = y0;
				y0 = y1;
			}
			cY[mNx] = y1;
		}
	//----    ------
		CRect rect;
		CBrush nb;

		int x1 = size.cx - 120;
		int x0 = (int)(Mx*size.cx/Nx) + 10;

		int step = (int)(x1-x0)/Nc;
		for(int M=0; M<Nc; M++)
		{
			nb.CreateSolidBrush(GetColor(M));
			m_dc->SelectObject(&nb);
				rect.left = x0 + M*step;
				rect.right = rect.left + step;
				rect.bottom = size.cy;
				rect.top = rect.bottom - step;
			m_dc->FillRect(rect,&nb);
			nb.DeleteObject();
		}
	//----------------
	//  
		CString str;

			Jx = size.cx - 120;
		str.Format("max=%g",max);
		m_dc->TextOut(Jx,size.cy-40,str,str.GetLength());
		str.Format("min=%g",min);
		m_dc->TextOut(Jx,size.cy-20,str,str.GetLength());
	}
}
//---------------------------------------------------------------------------
void CMainFrame::SetColorArray()
{
//         m_clr

	m_clr.SetSize(Nc+1);

	int i;
	int mid = Nc/2;
	int iTemp = 255/mid;

	int m1 = (int)(Nc*0.3);
	int m2 = (int)(Nc*0.5);
	int m3 = (int)(Nc*0.7);

	for(i=0; i<m1; i++)
		m_clr[i].color[0] = RGB(255, i*255/m1, 0);

	for(i=m1; i<m2; i++)
		m_clr[i].color[0] = RGB(255-(i-m1)*150/(m2-m1),255, 0);

	m_clr[m2].color[0] = RGB(0,255, 0);

	for(i=m2+1; i<m3; i++)
		m_clr[i].color[0] = RGB(0,255,(255-150)+(i-m2)*150/(m3-m2));

	for(i=m3; i<Nc; i++)
		m_clr[i].color[0] = RGB(0,255-(i-Nc)*255/(Nc-m3),255);

	m_clr[Nc].color[0] = RGB(126,126,126);


	
	mid = 255/Nc;
	for(i=0; i<Nc; i++)
	{
		iTemp = i*mid;
		m_clr[i].color[1] = RGB(iTemp, iTemp, iTemp);
	}
	m_clr[Nc].color[1] = RGB(126,126,126);
//---------------------
	for(i=0; i<Nc; i++)
	{
		(CBrush*) pBrush[i] = new CBrush(GetColor(i));
	}

	(CPen*) pPen[0] = new CPen(PS_SOLID,1,dwColor[0]);
	(CPen*) pPen[1] = new CPen(PS_SOLID,2,dwColor[1]);
	(CPen*) pPen[2] = new CPen(PS_SOLID,2,dwColor[2]);
	(CPen*) pPen[3] = new CPen(PS_SOLID,3,RGB(255,0,0));
}
//---------------------------------------------------------------------------
void CMainFrame::UpdateAxis(enum JC_GAS Jg, int add)
{
//   

	dbe = (double)((be+add)*M_PI_180);
	dal = (double)(al*M_PI_180);

// X  
	int xr = (int)(cos(dbe)*l_x);
	int yr = (int)(sin(dal)*sin(dbe)*l_x);
	p_x.x = -xr;
	p_x.y = yr;

// Y
	xr = (int)(sin(dbe)*l_y);
	yr = (int)(cos(dbe)*sin(dal)*l_y);
	p_y.x = xr;
	p_y.y = yr;

// Z
	yr = (int)(l_z*cos(dal));
	p_z.x = 0;
	p_z.y = -yr;

// X = 0, Y = 0
double	min = m_Range[Jg][0];
double	max = m_Range[Jg][1];
double zero = 0;

//if ((max>0)&&(min<0))	
zero = min/(min-max);

	yr = (int)(zero*l_z*cos(dal));
	p_xy0beg.x = 0;
	p_xy0beg.y = -yr;


	p_x0end.x = p_x.x + p_xy0beg.x;
	p_x0end.y = p_x.y + p_xy0beg.y;

	p_y0end.x = p_y.x + p_xy0beg.x;
	p_y0end.y = p_y.y + p_xy0beg.y;

//      
	c.x = center.x - (int)(p_x.x + p_y.x + p_z.x)/2;  
	c.y = center.y - (int)(p_x.y + p_y.y + p_z.y)/2;

//      
	p_x.x += c.x;	p_x.y += c.y;
	p_y.x += c.x;	p_y.y += c.y;
	p_z.x += c.x;	p_z.y += c.y;

//      X=0,Y=0
	p_xy0beg.x += c.x;
	p_xy0beg.y += c.y;

	p_x0end.x += c.x;
	p_x0end.y += c.y;

	p_y0end.x += c.x;
	p_y0end.y += c.y;
}
//---------------------------------------------------------------------------
void CMainFrame::UpdatePointObj(enum JC_GAS Jg)
{
//   

     int mY, mX, i,j;
	 double min,max;
	 
	 min = m_Range[Jg][0];
	 max = m_Range[Jg][1];

	 POINT p_R = {0,0};

	 mX = mNx - 1;
	 mY = mNy - 1;
	 
	 // 

	double p1 = cos(dbe)*l_x/mX;
	double p2 = sin(dbe)*sin(dal)*l_x/mX;
	double g1 = sin(dbe)*l_y/mY;
	double g2 = cos(dbe)*sin(dal)*l_y/mY;
	double r1 = l_z/(max - min)*cos(dal);
	double y;

	for(j=0; j<=mY; j++)
	for(i=0; i<=mX; i++)
	{
		y = matrix[Jg][i][j];

		// 
		p_R.x = -(int)(i*p1) + (int)(j*g1) + c.x;
		p_R.y = (int)(i*p2) + (int)(j*g2) - (int)((y-min)*r1) + c.y;

		m_Point[Jg][j][i] = p_R;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::AxisDraw(CDC* pDC)
{
//    ,    UpdateAxis
	CPen *oldpen, pen;

// X=0,Y=0
	oldpen = pDC->SelectObject(pPen[2]);

	pDC->MoveTo(p_xy0beg);
	pDC->LineTo(p_x0end);

	pDC->MoveTo(p_xy0beg);
	pDC->LineTo(p_y0end);

//  
	pDC->SelectObject(pPen[1]);

// Y
	pDC->MoveTo(c);	pDC->LineTo(p_y);

// X
	pDC->MoveTo(c);	pDC->LineTo(p_x);

// Z
	pDC->MoveTo(c);	pDC->LineTo(p_z);

    pDC->SelectObject(oldpen);
	pen.DeleteObject();
}
//---------------------------------------------------------------------------
void CMainFrame::MatrixDraw(CDC* pDC, enum JC_GAS Jg, int add) 
{
//	    ,  
//	  UpdatePointObj
if (pDC)
{
	POINT polygpts[4];
	int l0,l1,l2,l3,l4,l5, i,j;

	int	Nx = mNx - 1;
	int	Ny = mNy - 1;
	int oldColor,color;
	double Z;
	int M;
	int bet = be + add;
	CPen   *oldpen;
	CBrush *oldbrush;
	CBrush newbrush;

	oldpen = pDC->SelectObject(pPen[0]);

	newbrush.CreateSolidBrush(dwColor[3]);
	oldbrush = pDC->SelectObject(&newbrush);//   

//     

if ( bet >= 360)	bet -= 360;
if ( bet < 0)		bet += 360;

////////////////////////////////////////////////////////////////////////////////////
	if ( (bet >= 0) && (bet <= 90) )
	{
		oldColor = -1;

		for(j=0; j<Ny; j++)
		{
			l0=0; l1=1; l2=2; l3=3;
			polygpts[l0] = m_Point[Jg][j][0];
			polygpts[l1] = m_Point[Jg][j+1][0];

			for(i=0; i<Nx; i++)
			{
    			polygpts[l2] = m_Point[Jg][j+1][i+1];
				polygpts[l3] = m_Point[Jg][j][i+1];

				if ( mask[i][j] && mask[i+1][j] && mask[i][j+1] && mask[i+1][j+1] )
				{
					//--------
					if((m_wndToolBar.GetToolBarCtrl()).IsButtonChecked(ID_BUTTON_COLOR))
					{
						Z = 0.25*(matrix[Jg][i][j] + matrix[Jg][i+1][j] + matrix[Jg][i][j+1] + matrix[Jg][i+1][j+1]);
						color = Nc;
						for(M=0 ;M<Nc; M++)
						{
							if( Z <= GetLevels(M,Jg) )
							{
								color=M;
								break;
							}
						}

						if (oldColor!=color)
						{
							pDC->SelectObject(pBrush[color]);//   
							oldColor = color;
						}
					}
					//--------
					pDC->Polygon(polygpts,4);
				}
				l4 = l0;	l5 = l1;
				l0 = l3;	l1 = l2;
				l2 = l5;	l3 = l4;
			}
		}
	}
////////////////////////////////////////////////////////////////////////////////////
	if ( (bet > 90) && (bet <= 180) )
	{
for (j=Ny-1; j>-1; j--)
{
	l0=0; l1=1; l2=2; l3=3;
	polygpts[l0] = m_Point[Jg][j][0];
	polygpts[l1] = m_Point[Jg][j+1][0];

	for(i=0; i<Nx; i++)
	{
    	polygpts[l2] = m_Point[Jg][j+1][i+1];
	    polygpts[l3] = m_Point[Jg][j][i+1];

		if ( mask[i][j] && mask[i+1][j] && mask[i][j+1] && mask[i+1][j+1] )
		{
			//--------
			if((m_wndToolBar.GetToolBarCtrl()).IsButtonChecked(ID_BUTTON_COLOR))

			{
				Z = 0.25*(matrix[Jg][i][j] + matrix[Jg][i+1][j] + matrix[Jg][i][j+1] + matrix[Jg][i+1][j+1]);
				color = Nc;
				for(M=0 ;M<Nc; M++)
				{
					if( Z <= GetLevels(M,Jg) )
					{
						color=M;
						break;
					}
				}

				if (oldColor!=color)
				{
					pDC->SelectObject(pBrush[color]);//   
					oldColor = color;
				}
			}
			//--------

			pDC->Polygon(polygpts,4);
		}
		l4 = l0; l5 = l1;
		l0 = l3; l1 = l2;
		l2 = l5; l3 = l4;
	}
}
// X=0,Y=0
	pDC->SelectObject(pPen[2]);

	pDC->MoveTo(p_xy0beg);
	pDC->LineTo(p_x0end);

	pDC->SelectObject(pPen[1]);

// Y
//	pDC->MoveTo(c);
//	pDC->LineTo(p_y);

// X
	pDC->MoveTo(c);
	pDC->LineTo(p_x);

// Z
	pDC->MoveTo(c);
	pDC->LineTo(p_z);
	}
////////////////////////////////////////////////////////////////////////////////////
	if ( (bet > 180) && (bet <= 270) )
	{
for (j=Ny-1; j>-1; j--)
{
	l0=0; l1=1; l2=2; l3=3;
	polygpts[l0] = m_Point[Jg][j][Nx];
	polygpts[l1] = m_Point[Jg][j+1][Nx];

	for(i=Nx-1; i>-1; i--)
	{
    	polygpts[l2] = m_Point[Jg][j+1][i];
	    polygpts[l3] = m_Point[Jg][j][i];

		if ( mask[i][j] && mask[i+1][j] && mask[i][j+1] && mask[i+1][j+1] )
		{
			if((m_wndToolBar.GetToolBarCtrl()).IsButtonChecked(ID_BUTTON_COLOR))

			{
				Z = 0.25*(matrix[Jg][i][j] + matrix[Jg][i+1][j] + matrix[Jg][i][j+1] + matrix[Jg][i+1][j+1]);
				color = Nc;
				for(M=0; M<Nc; M++)
				{
					if( Z <= GetLevels(M,Jg) )
					{
						color=M;
						break;
					}
				}

				if (oldColor!=color)
				{
					pDC->SelectObject(pBrush[color]);//   
					oldColor=color;
				}
			}
			//--------

			pDC->Polygon(polygpts,4);
		}
		l4 = l0;	l5 = l1;
		l0 = l3;	l1 = l2;
		l2 = l5;	l3 = l4;
	}
}
	AxisDraw(pDC);
	}
////////////////////////////////////////////////////////////////////////////////////
	if( (bet > 270) && (bet <= 360) )
	{
for(j=0; j<Ny; j++)
{
	l0=0; l1=1; l2=2; l3=3;
	polygpts[l0] = m_Point[Jg][j][Nx];
	polygpts[l1] = m_Point[Jg][j+1][Nx];

	for(i=Nx-1; i>-1; i--)
	{
    	polygpts[l2] = m_Point[Jg][j+1][i];
	    polygpts[l3] = m_Point[Jg][j][i];

		if ( mask[i][j] && mask[i+1][j] && mask[i][j+1] && mask[i+1][j+1] )
		{
			//--------
			if((m_wndToolBar.GetToolBarCtrl()).IsButtonChecked(ID_BUTTON_COLOR))

			{
				Z = 0.25*(matrix[Jg][i][j] + matrix[Jg][i+1][j] + matrix[Jg][i][j+1] + matrix[Jg][i+1][j+1]);
				color = Nc;
				for(M=0 ;M<Nc; M++)
				{
					if( Z <= GetLevels(M,Jg) )
					{
						color=M;
						break;
					}
				}

				if (oldColor != color)
				{
					pDC->SelectObject(pBrush[color]);//   
					oldColor = color;
				}
			}
			//--------

			pDC->Polygon(polygpts,4);
		}
		l4 = l0;	l5 = l1;
		l0 = l3;	l1 = l2;
		l2 = l5;	l3 = l4;
	}
}

// X=0,Y=0
	pDC->SelectObject(pPen[2]);

	pDC->MoveTo(p_xy0beg);
	pDC->LineTo(p_y0end);

	pDC->SelectObject(pPen[1]);

// Y
	pDC->MoveTo(c);
	pDC->LineTo(p_y);

// X
//	pDC->MoveTo(c);
//	pDC->LineTo(p_x);

// Z
	pDC->MoveTo(c);
	pDC->LineTo(p_z);
	}

    pDC->SelectObject(oldpen);	
	pDC->SelectObject(oldbrush);
	newbrush.DeleteObject();
}
}
//---------------------------------------------------------------------------
void CMainFrame::Surface(CDC* m_dc, 
						 CRect* rcClient, 
						 enum JC_GAS Jg,
						 int n3DS, 
						 int add_angle)
{
	int		Jx,i,nmin;
	double	min=m_Range[Jg][0];
	double	max=m_Range[Jg][1];

	size = rcClient->Size();
	nmin = size.cx;
	if (nmin > size.cy)	nmin = size.cy;

//     
	switch (n3DS)
	{
	case 3:
		{
			i = (int)(Scale3D*nmin);
				((Proc3D*)p3D[Jg])->size = size;
				center.x = ( ((Proc3D*)p3D[Jg])->center.x + ((Proc3D*)p3D[Jg])->displacement.x );
				center.y = ( ((Proc3D*)p3D[Jg])->center.y +	((Proc3D*)p3D[Jg])->displacement.y );
		} break;
	case 4:
		{
			i = (int)(ScaleStereo*nmin);
				((ProcStereo*)pStereo[Jg])->size = size;
				center.x = ( ((ProcStereo*)pStereo[Jg])->center.x + ((ProcStereo*)pStereo[Jg])->displacement.x);
				center.y = ( ((ProcStereo*)pStereo[Jg])->center.y + ((ProcStereo*)pStereo[Jg])->displacement.y);
		} break;
	}

	l_z = i;

	if (Ly>Lx)
	{
		l_x = i;
		l_y = (int)(i*Ly/Lx);
	}
	else
	{
		l_y = i;
		l_x = (int)(i*Lx/Ly);
	}

	CBrush brush(::GetSysColor(COLOR_WINDOW));
	CBrush* oldbrush;
	oldbrush = m_dc->SelectObject(&brush);
	m_dc->FillRect(rcClient,&brush);
	m_dc->SelectObject(oldbrush);
	brush.DeleteObject();

	UpdateAxis(Jg, add_angle);
	UpdatePointObj(Jg);
	AxisDraw(m_dc);
	MatrixDraw(m_dc, Jg, add_angle);

CString str;
		Jx = size.cx-120;
	str.Format("max=%g",max);
	m_dc->TextOut(Jx,size.cy-40,str,str.GetLength());
	str.Format("min=%g",min);
	m_dc->TextOut(Jx,size.cy-20,str,str.GetLength());

	SetEvent(m_hEventNeedNotDC);
}
//---------------------------------------------------------------------------
LRESULT CMainFrame::OnTitle(WPARAM, LPARAM)
{
	UpdateTitle();
	bTitle = FALSE;
	return 0;
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonR() 
{
	Jc_Wnd = Jg_R;
	CheckWindow(Jg_R, n2D3DS_create, FALSE);
	
	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_R])->BringWindowToTop();		} break;
	case 3: { ((Proc3D*) p3D[Jg_R])->BringWindowToTop();		} break;
	case 4: { ((ProcStereo*) pStereo[Jg_R])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonP() 
{
	Jc_Wnd = Jg_P;
	CheckWindow(Jg_P, n2D3DS_create, FALSE);

	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_P])->BringWindowToTop();		} break; 
	case 3: { ((Proc3D*) p3D[Jg_P])->BringWindowToTop();		} break; 
	case 4: { ((ProcStereo*) pStereo[Jg_P])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonE() 
{
	Jc_Wnd = Jg_E;
	CheckWindow(Jg_E, n2D3DS_create,FALSE);

	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_E])->BringWindowToTop();		} break;
	case 3: { ((Proc3D*) p3D[Jg_E])->BringWindowToTop();		} break;
	case 4: { ((ProcStereo*) pStereo[Jg_E])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonM() 
{
	Jc_Wnd = Jg_M;
	CheckWindow(Jg_M, n2D3DS_create,FALSE);
	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_M])->BringWindowToTop();		 } break;
	case 3: { ((Proc3D*) p3D[Jg_M])->BringWindowToTop();		 } break;
	case 4: { ((ProcStereo*) pStereo[Jg_M])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonH() 
{
	Jc_Wnd = Jg_H;
	CheckWindow(Jg_H, n2D3DS_create,FALSE);
	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_H])->BringWindowToTop();		 } break;
	case 3: { ((Proc3D*) p3D[Jg_H])->BringWindowToTop();		 } break;
	case 4: { ((ProcStereo*) pStereo[Jg_H])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonS() 
{
	Jc_Wnd = Jg_S;
	CheckWindow(Jg_S, n2D3DS_create,FALSE);
	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_S])->BringWindowToTop();		} break;
	case 3: { ((Proc3D*) p3D[Jg_S])->BringWindowToTop();		} break;
	case 4: { ((ProcStereo*) pStereo[Jg_S])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonU() 
{
	Jc_Wnd = Jg_U;
	CheckWindow(Jg_U, n2D3DS_create,FALSE);
	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_U])->BringWindowToTop();	}	break;
	case 3: { ((Proc3D*) p3D[Jg_U])->BringWindowToTop();	}	break;
	case 4: { ((ProcStereo*) pStereo[Jg_U])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonUx() 
{
	Jc_Wnd = Jg_Ux;
	CheckWindow(Jg_Ux, n2D3DS_create,FALSE);
	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_Ux])->BringWindowToTop();	}	break;
	case 3: { ((Proc3D*) p3D[Jg_Ux])->BringWindowToTop();	}	break;
	case 4: { ((ProcStereo*) pStereo[Jg_Ux])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonUy() 
{
	Jc_Wnd = Jg_Uy;
	CheckWindow(Jg_Uy, n2D3DS_create,FALSE);
	switch (n2D3DS_create)
	{
	case 2: { ((Proc2D*) p2D[Jg_Uy])->BringWindowToTop();	}	break;
	case 3: { ((Proc3D*) p3D[Jg_Uy])->BringWindowToTop();	}	break;
	case 4: { ((ProcStereo*) pStereo[Jg_Uy])->BringWindowToTop(); } break;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::OnButton2D()		{ n2D3DS_create = 2; }
void CMainFrame::OnButton3D()		{ n2D3DS_create = 3; }
void CMainFrame::OnButtonStereo()	{ n2D3DS_create = 4; }
void CMainFrame::OnButtonColor()	{ CheckWindow(Jc_Wnd, n3DS_rotate,TRUE);}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonTools()
{
	if (!pSheetDialog)
	{
		pSheetDialog = new SheetDialog(this);
		pSheetDialog->Create(IDD_SHEET_DIALOG,this);
	}
	pSheetDialog->ShowWindow(SW_NORMAL);
	pSheetDialog->SetActiveWindow();
	pSheetDialog->BringWindowToTop();
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonInc() 
{
	switch (n3DS_rotate)	
	{
	case 3: { Scale3D += 0.1;	  if (Scale3D>5) Scale3D=5;			} break;
	case 4: { ScaleStereo += 0.1; if (ScaleStereo>5) ScaleStereo=5; } break;
	}
	CheckWindow(Jc_Wnd, n3DS_rotate,TRUE);
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonDec() 
{
	switch (n3DS_rotate)	
	{
	case 3: { Scale3D -= 0.1;	  if (Scale3D<0.1) Scale3D=0.1;			} break;
	case 4: { ScaleStereo -= 0.1; if (ScaleStereo<0.1) ScaleStereo=0.1; } break;
	}
	CheckWindow(Jc_Wnd, n3DS_rotate,TRUE);
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonRight() 
{
	be += 5;
	if (be > 360)	be = 5;

	CheckWindow(Jc_Wnd, n3DS_rotate,TRUE);
	bRotate = false;
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonLeft() 
{
	be -= 5;
	if (be < 0)	be = 355;

	CheckWindow(Jc_Wnd, n3DS_rotate,TRUE);
	bRotate = false;
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonDown() 
{
	al += 5;
	if (al > 360) al = 5;

	CheckWindow(Jc_Wnd, n3DS_rotate,TRUE);
	bRotate = false;
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonUp() 
{
	al -= 5;
	if (al < 0)	al = 355;

	CheckWindow(Jc_Wnd, n3DS_rotate,TRUE);
	bRotate = false;
}
//---------------------------------------------------------------------------
void CMainFrame::Rotate(BOOL go)
{
	if (go)
	{
		if(!SetTimer(1, 50, NULL)) AfxMessageBox("SetTimer() failure");

		switch (nDirection)
		{
			case 1: OnButtonUp();	 break;
			case 2: OnButtonLeft();	 break;
			case 3: OnButtonRight(); break;
			case 4: OnButtonDown();	 break;
		}
	}
	else	KillTimer(1);
}
//---------------------------------------------------------------------------
void CMainFrame::OnTimer(UINT nIDEvent) 
{
//	  3D 
	if (!bRotate)
	{
		bRotate = true;
		switch (nDirection)
		{
			case 1: OnButtonUp();	 break;
			case 2: OnButtonLeft();	 break;
			case 3: OnButtonRight(); break;
			case 4: OnButtonDown();	 break;
		}
	}

	CMDIFrameWnd::OnTimer(nIDEvent);
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonGo()
{
	bRunRequest = true;
	SetEvent(m_hRunRequest);
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonPause()
{
	bRunRequest = false;
	ResetEvent(m_hRunRequest);
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonInit()
{
	//     ""
	m_wndToolBar.GetToolBarCtrl().CheckButton(ID_BUTTON_PAUSE, TRUE);

	bInitCalculations = true;
	//  ,     InitCalculations();
	SetEvent(m_hRunRequest);
}
//---------------------------------------------------------------------------
void CMainFrame::OnButtonPaint() 
{
	if (!bExecuteOnButtonPaint) //    
		// ,    
	{
		bExecuteOnButtonPaint = TRUE;

		bRepaint = true;
		//  ,     Show();
		SetEvent(m_hRunRequest);

		bExecuteOnButtonPaint = FALSE;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::Show() 
{
//        Data 
//    Data
//  bExecuteOnButtonPaint    
//    Data,    
//   "Re"
TRACE0("\nCMainFrame::Show()    FillMatrix()");
//	if (pData) ((Data*) pData)->FillMatrix();
	FillMatrix();

TRACE0("\nCMainFrame::Show()    SetIsolLevels()");
	SetIsolLevels();

TRACE0("\nCMainFrame::Show()    UpdateTitle()");
	UpdateTitle();

TRACE0("\nCMainFrame::Show()    for()");
	for (int n=0; n<NF; n++)
	{
		if (p2D[n])	((Proc2D*) p2D[n])->PicBox();
		if (p3D[n])	((Proc3D*) p3D[n])->PicBox();
		if (pStereo[n])	((ProcStereo*) pStereo[n])->PicBox();
	}
TRACE0("\nCMainFrame::Show()    (end)");
}
//---------------------------------------------------------------------------
void CMainFrame::FillMatrix()
{
//   matrix    : (R,Ux,Uy,E,P,H,|U|,M,S)

	int x,y,k;
	double U,V;
	double A[NF];

// - - - - - - - - - - - - -
	for (y=mNy; y>=0;	y--)
	for (x=0;	x<=mNx; x++)
	{
	//	if (IsInGas(x,y))
		if (mask[x][y])
		{
		//RPEMHSU
			A[0] = U1[0][x][y];				// R
				U = U1[1][x][y]/A[0];
				V = U1[2][x][y]/A[0];
			A[7] = U;						// Ux
			A[8] = V;						// Uy
				U = U*U + V*V;
				V = U1[3][x][y]/A[0];
			A[2] = V - 0.5*U;				// E
			A[1] = A[0]*A[2]*(G - 1.);		// P
			A[4] = G*V - (G - 1.)*0.5*U;	// H
				V = (G - 1.)*(A[4] - U*0.5);
			A[6] = sqrt(U);					//|U|
			A[3] = sqrt(U/V);				// M
			A[5] = A[1]*exp(-G*log(A[0]));	// S
   
			for (k=0; k<NF; k++) matrix[k][x][y] = A[k];
		}
		else for (k=0; k<NF; k++) matrix[k][x][y] = 0;
	}
}
//---------------------------------------------------------------------------
void CMainFrame::FirstShow()
{
	SetColorArray();
	InitCalculations();

	if (!pData)
	{
		pData = new Data();
		pData->CreateThread(CREATE_SUSPENDED);
		pData->SetOwner(this);
	}

	Show();
	InitCalculations();

	OnButtonH();
	OnButtonP();
	OnButtonM();
	n2D3DS_create = 3;
	OnButtonR();
	OnButtonS();
	n2D3DS_create = 2;

	MDITile(MDITILE_HORIZONTAL);
	UpdateWindow();

	bRunRequest = true;
	SetEvent(m_hRunRequest);

	pData->ResumeThread();
}
//---------------------------------------------------------------------------
BOOL CMainFrame::IsInGas(int ix, int iy)
{
	//if ( (((ix>Mx_) && (iy<My_)) || (ix>Nx_)) ||(iy>Ny_) )
	//	 return FALSE;
	//else 
		return TRUE;
}
//---------------------------------------------------------------------------
