/////////////////////////////////////////////////////////////////////////////
// Proc2D.cpp
//

#include "stdafx.h"
#include "MainFrm.h"
#include "Proc2D.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	Proc2D* p2D[NF];
extern int	Nx,Ny,Nc;

/////////////////////////////////////////////////////////////////////////////
// Proc2D

IMPLEMENT_DYNCREATE(Proc2D, CMDIChildWnd)

BEGIN_MESSAGE_MAP(Proc2D, CMDIChildWnd)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
END_MESSAGE_MAP()

Proc2D::Proc2D()
{
}
Proc2D::~Proc2D()
{
	p2D[Jg]=NULL;
}
//---------------------------------------------------------------------------
BOOL Proc2D::Create(LPCTSTR szTitle, LONG style /* = 0 */,
	const RECT& rect /* = rectDefault */,
	CMDIFrameWnd* parent /* = NULL */,enum JC_GAS J)
{
	m_pParent = parent;
	Jg = J;

	// Register a custom WndClass and create a window.
	// This must be done because CBounceWnd has a custom cursor, and
	//  no icon.
	LPCTSTR lpszBounceClass =
		AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW,
			LoadCursor(NULL, IDC_ARROW),
			(HBRUSH)(COLOR_WINDOW+1),
			NULL);

	return CMDIChildWnd::Create(lpszBounceClass, szTitle, style, rect, parent);
}
/////////////////////////////////////////////////////////////////////////////
// Proc2D diagnostics

//#ifdef _DEBUG
//void Proc2D::AssertValid() const
//{
//	CMDIChildWnd::AssertValid();
//}
//
//void Proc2D::Dump(CDumpContext& dc) const
//{
//	CMDIChildWnd::Dump(dc);
//}
//
//#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Proc2D message handlers
//---------------------------------------------------------------------------
void Proc2D::PicBox()
{
	if (m_dc)
	{
		CRect rectClient;

		GetClientRect(rectClient);
		size = rectClient.Size();

	//----      ------

		CBrush brush(::GetSysColor(COLOR_WINDOW));
		m_dc.FillRect(rectClient,&brush);

	//--------------------------------------------------


		((CMainFrame*)m_pParent)->Isoline(&m_dc, &rectClient, Jg, size);

		CClientDC dc(this);
	//     dc (  )
		dc.BitBlt(0, 0, size.cx, size.cy, &m_dc, 0, 0, SRCCOPY);
	}
}
//---------------------------------------------------------------------------
void Proc2D::OnSize(UINT nType, int cx, int cy) 
{
	CMDIChildWnd::OnSize(nType, cx, cy);

	if (nType!=SIZE_MINIMIZED)
	{

		switch (nType)
		{
		case SIZE_MAXIMIZED: {
			((CMainFrame*)m_pParent)->nType=SW_SHOWMAXIMIZED; break; }
		case SIZE_RESTORED:;
		case SIZE_MAXSHOW:  {
			((CMainFrame*)m_pParent)->nType=SW_SHOWNORMAL; break; }
		}

		PicBox();
	}
}
//---------------------------------------------------------------------------
void Proc2D::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	dc.BitBlt(0, 0, size.cx, size.cy, &m_dc, 0, 0, SRCCOPY);
}
//---------------------------------------------------------------------------
void Proc2D::OnSetFocus(CWnd* pOldWnd) 
{
	CMDIChildWnd::OnSetFocus(pOldWnd);

	((CMainFrame*)m_pParent)->Jc_Wnd = Jg;
//	PicBox();
}
//---------------------------------------------------------------------------
BOOL Proc2D::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	CClientDC dc(this);

	if(!m_dc.CreateCompatibleDC(NULL))
		AfxMessageBox(_T("InitPicBox2D: !m_dc.CreateCompatibleDC(NULL)"));

	BITMAP bm;
	bm.bmType      = 0;
	bm.bmWidth     = dc.GetDeviceCaps(HORZRES);
	bm.bmHeight    = dc.GetDeviceCaps(VERTRES);
	bm.bmPlanes    = dc.GetDeviceCaps(PLANES);
	bm.bmBitsPixel = dc.GetDeviceCaps(BITSPIXEL);
	bm.bmBits      = NULL;
	bm.bmWidthBytes  = (int)bm.bmBitsPixel*bm.bmWidth/8 + 2;

	if(!bitmap.CreateBitmapIndirect(&bm))
		AfxMessageBox(_T("InitPicBox2D: !bitmap.CreateBitmapIndirect(&bm)"));

	pOldBitmap = m_dc.SelectObject(&bitmap);
	
	return CMDIChildWnd::OnCreateClient(lpcs, pContext);
}
//---------------------------------------------------------------------------
