/////////////////////////////////////////////////////////////////////////////
// Proc3D.cpp
//
#include "stdafx.h"
#include "MainFrm.h"
#include "Gasdynamics.h"
#include "Proc3D.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	Proc3D* p3D[NF];
extern int	Nc;
extern double Lx,Ly;

//extern HANDLE m_hEventNeedNotDC;

/////////////////////////////////////////////////////////////////////////////
// Proc3D

IMPLEMENT_DYNCREATE(Proc3D, CMDIChildWnd)

BEGIN_MESSAGE_MAP(Proc3D, CMDIChildWnd)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_SETFOCUS()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_KILLFOCUS()
END_MESSAGE_MAP()

Proc3D::Proc3D()
{
	displacement.x = 0;
	displacement.y = 0;
	bFirstFocus = TRUE;	
}

Proc3D::~Proc3D()
{
	p3D[Jg] = NULL;
}
//---------------------------------------------------------------------------
BOOL Proc3D::Create(LPCTSTR szTitle, LONG style /* = 0 */,
	const RECT& rect /* = rectDefault */,
	CMDIFrameWnd* parent /* = NULL */,enum JC_GAS J)
{
	m_pParent = parent;
	Jg = J;

	LPCTSTR lpszBounceClass =
		AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW,
			NULL, (HBRUSH)(COLOR_WINDOW+1),	NULL);

	return CMDIChildWnd::Create(lpszBounceClass, szTitle, style, rect, parent);	
}
//---------------------------------------------------------------------------
void Proc3D::PicBox()
{
	if (m_dc)
	{
		ResetEvent(((CMainFrame*)m_pParent)->m_hEventNeedNotDC);

		GetClientRect(rcClient);
		((CMainFrame*)m_pParent)->Surface(&m_dc, &rcClient, Jg, 3,0);

		CClientDC dc(this);
		dc.BitBlt(0, 0, size.cx, size.cy, &m_dc, 0, 0, SRCCOPY);
	}
}
//---------------------------------------------------------------------------
void Proc3D::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	dc.BitBlt(0, 0, size.cx, size.cy, &m_dc, 0, 0, SRCCOPY);
}
//---------------------------------------------------------------------------
void Proc3D::OnSize(UINT nType, int cx, int cy) 
{
	CMDIChildWnd::OnSize(nType, cx, cy);

	if (nType != SIZE_MINIMIZED)
	{
		switch (nType)
		{
		case SIZE_MAXIMIZED:
			((CMainFrame*)m_pParent)->nType = SW_SHOWMAXIMIZED;		break;
		case SIZE_RESTORED:;
		case SIZE_MAXSHOW:
			((CMainFrame*)m_pParent)->nType = SW_SHOWNORMAL;	break;
		}

		int x = (int)cx/2;
		int y = (int)cy/2;
		cursor_center.x = x;//      
		cursor_center.y = y;

		if (x<y) y = x;
		center.x = y;//  
		center.y = y;


	//    
		displacement.x = (int)(displacement.x*cx/oldSize.cx);
		displacement.y = (int)(displacement.y*cy/oldSize.cy);

		oldSize.cx = cx;
		oldSize.cy = cy;

		PicBox();
	}
}
//---------------------------------------------------------------------------
void Proc3D::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (nFlags!=MK_LBUTTON)
	{
		switch ( Direction(point) )
		{
			case 1: { SetCursor(AfxGetApp()->LoadCursor(IDC_UP));   break; }
			case 2: { SetCursor(AfxGetApp()->LoadCursor(IDC_LEFT)); break; }
			case 3: { SetCursor(AfxGetApp()->LoadCursor(IDC_RIGHT));break; }
			case 4: { SetCursor(AfxGetApp()->LoadCursor(IDC_DOWN)); break; }
		}
	}
	else
	{
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEALL));
		displacement.x += point.x - oldPoint.x;
		displacement.y += point.y - oldPoint.y;
		oldPoint = point;
		PicBox();
	}

	CMDIChildWnd::OnMouseMove(nFlags, point);
}
//---------------------------------------------------------------------------
void Proc3D::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if (nFlags != MK_LBUTTON)
	{
		Direction(point);

		((CMainFrame*)m_pParent)->Rotate(TRUE);
	}

	CMDIChildWnd::OnRButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void Proc3D::OnLButtonDown(UINT nFlags, CPoint point) 
{
	oldPoint=point;

	if (bFirstFocus)
	{
		bFirstFocus=FALSE;

		((CMainFrame*)m_pParent)->Jc_Wnd=Jg;
		((CMainFrame*)m_pParent)->n3DS_rotate=3;
//		PicBox();
	}
	else
	{
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEALL));
	}
	CMDIChildWnd::OnLButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------
void Proc3D::OnRButtonUp(UINT nFlags, CPoint point) 
{
	((CMainFrame*)m_pParent)->Rotate(FALSE);
	
	CMDIChildWnd::OnRButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
void Proc3D::OnLButtonUp(UINT nFlags, CPoint point) 
{
	switch ( Direction(point) )
	{
		case 1: {	SetCursor(AfxGetApp()->LoadCursor(IDC_UP));   break; }
		case 2: {	SetCursor(AfxGetApp()->LoadCursor(IDC_LEFT)); break; }
		case 3: {	SetCursor(AfxGetApp()->LoadCursor(IDC_RIGHT));break; }
		case 4: {	SetCursor(AfxGetApp()->LoadCursor(IDC_DOWN)); break; }
	}	

	CMDIChildWnd::OnLButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------
BOOL Proc3D::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	CClientDC dc(this);

	if(!m_dc.CreateCompatibleDC(NULL))
		AfxMessageBox(_T("InitPicBox3D: !m_dc.CreateCompatibleDC(NULL)"));

	BITMAP bm;
	bm.bmType      = 0;
	bm.bmWidth     = dc.GetDeviceCaps(HORZRES);
	bm.bmHeight    = dc.GetDeviceCaps(VERTRES);
	bm.bmPlanes    = dc.GetDeviceCaps(PLANES);
	bm.bmBitsPixel = dc.GetDeviceCaps(BITSPIXEL);
	bm.bmBits      = NULL;
	bm.bmWidthBytes  = (int)bm.bmBitsPixel*bm.bmWidth/8 + 2;

	if(!bitmap.CreateBitmapIndirect(&bm))
		AfxMessageBox(_T("InitPicBox3D: !bitmap.CreateBitmapIndirect(&bm)"));

//	CRect rect;
//	GetClientRect(&rect);
//	oldSize=rect.Size();

	pOldBitmap = m_dc.SelectObject(&bitmap);

	return CMDIChildWnd::OnCreateClient(lpcs, pContext);
}
//---------------------------------------------------------------------------
int Proc3D::Direction(CPoint point)
{
	POINT	p=cursor_center;
	int		n;
//
// cursor position:
//
//	  \  1  /
//		\ /
//	  2	 X  3
//      / \
//    /  4  \
//  Y  !
	if ( point.y>(p.y + (point.x - p.x)) )
	{//2,4
		if ( point.y>(p.y-(point.x-p.x)) )	n = 4;
									else	n = 2;
	}
	else
	{//1,3
		if ( point.y>(p.y-(point.x-p.x)) )	n = 3;
									else	n = 1;
	}

	((CMainFrame*)m_pParent)->nDirection=n;
	return n;
}
//---------------------------------------------------------------------------
void Proc3D::OnSetFocus(CWnd* pOldWnd) 
{
	CMDIChildWnd::OnSetFocus(pOldWnd);
	
	((CMainFrame*)m_pParent)->Jc_Wnd=Jg;
	((CMainFrame*)m_pParent)->n3DS_rotate=3;
//	PicBox();

}
//     OnSize,    
//    PicBox,     
// OnSetFocus.  OnSetFocus     
// PicBox,       .
//---------------------------------------------------------------------------
void Proc3D::OnNcLButtonDown(UINT nHitTest, CPoint point)
{
	((CMainFrame*)m_pParent)->Jc_Wnd=Jg;
	((CMainFrame*)m_pParent)->n3DS_rotate=3;
	PicBox();

	CMDIChildWnd::OnNcLButtonDown(nHitTest, point);
}
//---------------------------------------------------------------------------
void Proc3D::OnKillFocus(CWnd* pNewWnd) 
{
	CMDIChildWnd::OnKillFocus(pNewWnd);
	
	bFirstFocus=TRUE;	
}
//---------------------------------------------------------------------------
BOOL Proc3D::DestroyWindow() 
{
	WaitForSingleObject(((CMainFrame*)m_pParent)->m_hEventNeedNotDC, INFINITE);
	
	return CMDIChildWnd::DestroyWindow();
}
//---------------------------------------------------------------------------
