/////////////////////////////////////////////////////////////////////////////
// ProcStereo.cpp
//
#include "stdafx.h"
#include "MainFrm.h"
#include "Gasdynamics.h"
#include "Proc3D.h"
#include "ProcStereo.h"
#include "PaneStereo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	ProcStereo* pStereo[NF];
extern int	Nx,Ny,Nc;
/////////////////////////////////////////////////////////////////////////////
// ProcStereo

IMPLEMENT_DYNCREATE(ProcStereo, CMDIChildWnd)

BEGIN_MESSAGE_MAP(ProcStereo, CMDIChildWnd)
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_HSCROLL()
	ON_WM_NCACTIVATE()
END_MESSAGE_MAP()

ProcStereo::ProcStereo()
{
	First = true;
	displacement.x = 0;
	displacement.y = 0;
	pPaneStereo0 = NULL;
	pPaneStereo1 = NULL;
}

ProcStereo::~ProcStereo()
{
	pStereo[Jg] = NULL;
}
//---------------------------------------------------------------------------
void ProcStereo::OnSetFocus(CWnd* pOldWnd) 
{
	CMDIChildWnd::OnSetFocus(pOldWnd);

	((CMainFrame*)m_pParent)->Jc_Wnd=Jg;
	((CMainFrame*)m_pParent)->n3DS_rotate=4;
}
//---------------------------------------------------------------------------
BOOL ProcStereo::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
	{
		TRACE0("Failed to CreateStaticSplitter\n");
		return FALSE;
	}

	// add the first splitter pane - the default view in column 0
	if (!m_wndSplitter.CreateView(0, 0,
		RUNTIME_CLASS(PaneStereo), CSize((int)((lpcs->cx-11)*0.5),lpcs->cy), 
		&Context))
	{
		TRACE0("Failed to create first pane\n");
		return FALSE;
	}

	// add the second splitter pane - an input view in column 1
	if (!m_wndSplitter.CreateView(0, 1,
		RUNTIME_CLASS(PaneStereo), CSize(0, 0), &Context))
	{
		TRACE0("Failed to create second pane\n");
		return FALSE;
	}
//  Jc
	((PaneStereo*) m_wndSplitter.GetPane(0,0))->Jg = Jg;
	((PaneStereo*) m_wndSplitter.GetPane(0,1))->Jg = Jg;

//   
	((PaneStereo*) m_wndSplitter.GetPane(0,0))->add_angle=1; //for left eye
	((PaneStereo*) m_wndSplitter.GetPane(0,1))->add_angle=-1;//for right eye

	// activate the input view
////	SetActiveView((CView*)m_wndSplitter.GetPane(0,1));

//    
	SetScrollRange(SB_HORZ,20,200,FALSE);
	SetScrollPos(SB_HORZ, ((CMainFrame*)m_pParent)->baza, TRUE);

//  bitmap   pane ( OnCreateClient  3D)
	((PaneStereo*) m_wndSplitter.GetPane(0,0))->InitPicBoxStereo();
	((PaneStereo*) m_wndSplitter.GetPane(0,1))->InitPicBoxStereo();

	return CMDIChildWnd::OnCreateClient(lpcs, &Context);
}
//---------------------------------------------------------------------------
BOOL ProcStereo::Create(LPCTSTR szTitle, LONG style /* = 0 */,
	const RECT& rect /* = rectDefault */,
	CMDIFrameWnd* parent /* = NULL */, enum JC_GAS J)
{
	m_pParent = parent;
	Jg = J;

	Context.m_pNewViewClass = NULL;

	LPCTSTR lpszBounceClass =
		AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW,
			NULL, (HBRUSH)(COLOR_WINDOW+1), NULL);

	return CMDIChildWnd::Create(lpszBounceClass, szTitle, 
								style, rect, parent,&Context);
}
//---------------------------------------------------------------------------
void ProcStereo::PicBox()
{
	if (m_wndSplitter)
	{
		pPaneStereo1->PicBox();//for right eye
		pPaneStereo0->PicBox();//for left eye
	}
}
//---------------------------------------------------------------------------
void ProcStereo::OnSize(UINT nType, int cx, int cy) 
{
//    OnSize  m_pColInfo[col]
//  CSplitterWnd   
	if (First)
	{
		First = false; 
		oldSize.cx = cx;
		oldSize.cy = cy;
	}
	else if ((nType!=SIZE_MINIMIZED)&&(pPaneStereo1!=NULL)&&(pPaneStereo0!=NULL))
	{
		int y = (int)(cy*0.5);
	//	int x05=(int)((cx-11)*0.5);
		int x05 = (int)(cx*0.5);
		int x = (int)((cx-11)*0.25); // 11    CSplitterWnd
		if (x<0) x = 0;

		cursor_center.x = x;
		cursor_center.y = y;

		INT baza=((CMainFrame*)m_pParent)->baza;
	//     
		pPaneStereo0->center.x = x05 - baza;
		pPaneStereo0->center.y = y;

		pPaneStereo1->center.x = baza;
		pPaneStereo1->center.y = y;

	//	center.x = x;
	//	center.y = y;
		displacement.x = (int)(displacement.x*cx/oldSize.cx);
		displacement.y = (int)(displacement.y*cy/oldSize.cy);

		oldSize.cx = cx;
		oldSize.cy = cy;

		m_wndSplitter.SetColumnInfo(0,x05,0);//  
		m_wndSplitter.SetColumnInfo(1,x05,0);

		switch (nType)
		{
		case SIZE_MAXIMIZED: {
			((CMainFrame*)m_pParent)->nType=SW_SHOWMAXIMIZED; break; }
		case SIZE_RESTORED:;
		case SIZE_MAXSHOW:   {
			((CMainFrame*)m_pParent)->nType=SW_SHOWNORMAL;	  break; }
		}
	}
	CMDIChildWnd::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
}
//---------------------------------------------------------------------------
void ProcStereo::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	switch (nSBCode)
	{
	case SB_LINELEFT: { nPos=GetScrollPos(SB_HORZ); nPos--;	break; }
	case SB_LINERIGHT:{ nPos=GetScrollPos(SB_HORZ); nPos++;	break; }
	case SB_PAGERIGHT:{ nPos=GetScrollPos(SB_HORZ); nPos+=10;	break; }
	case SB_PAGELEFT: { nPos=GetScrollPos(SB_HORZ); nPos-=10;	break; }
	}

	if (nSBCode!=SB_ENDSCROLL)
	{
		int n=nPos-SetScrollPos(SB_HORZ, nPos);
		((CMainFrame*)m_pParent)->baza += n;
		//     
		pPaneStereo0->center.x -= n;
		pPaneStereo1->center.x += n;

		PicBox();
	}

//	CMDIChildWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}
//---------------------------------------------------------------------------
BOOL ProcStereo::OnNcActivate(BOOL bActive)
{
	if (bActive)
	{
		((CMainFrame*)m_pParent)->Jc_Wnd = Jg;
		((CMainFrame*)m_pParent)->n3DS_rotate = 4;

		if (m_wndSplitter)
		{
			pPaneStereo0=(PaneStereo*) m_wndSplitter.GetPane(0,0);
			pPaneStereo1=(PaneStereo*) m_wndSplitter.GetPane(0,1);
		}

		PicBox();
	}
	return CMDIChildWnd::OnNcActivate(bActive);
}
//---------------------------------------------------------------------------
