// Tool0.cpp : implementation file
//

#include "stdafx.h"
#include "gasdynamics.h"
#include "Tool0.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

	extern 	METHOD_TYPE eMethodType;
	extern	BOOL bRepaint;
	extern	double U0,P0,R0,G;

/////////////////////////////////////////////////////////////////////////////
// Tool0 property page

IMPLEMENT_DYNCREATE(Tool0, CPropertyPage)

Tool0::Tool0() : CPropertyPage(Tool0::IDD)
{

}

void Tool0::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_REPAINT, m_Repaint);
	DDX_Control(pDX, IDC_SPIN_U0, m_Spin_U0);
	DDX_Control(pDX, IDC_SPIN_P0, m_Spin_P0);
	DDX_Control(pDX, IDC_SPIN_R0, m_Spin_R0);
	DDX_Control(pDX, IDC_SPIN_G, m_Spin_G);

	DDX_Text(pDX, IDC_EDIT_U0, U0);
	DDX_Text(pDX, IDC_EDIT_R0, R0);
	DDX_Text(pDX, IDC_EDIT_P0, P0);
	DDX_Text(pDX, IDC_EDIT_G, G);
}


BEGIN_MESSAGE_MAP(Tool0, CPropertyPage)
	ON_BN_CLICKED(IDC_CHECK_REPAINT, OnCheckRepaint)
	ON_BN_CLICKED(IDC_RADIO_GOD, OnRadioGod)
	ON_BN_CLICKED(IDC_RADIO_LW,  OnRadioLW)
	ON_BN_CLICKED(IDC_RADIO_HAR, OnRadioHar)
	ON_WM_VSCROLL()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Tool0 message handlers
//---------------------------------------------------------------------------
void Tool0::OnCheckRepaint() { bRepaint=m_Repaint.GetCheck(); }
//---------------------------------------------------------------------------
BOOL Tool0::OnSetActive() 
{
	m_Repaint.SetCheck(bRepaint);

	m_Spin_U0.SetRange(0,1);
	m_Spin_P0.SetRange(0,1);
	m_Spin_R0.SetRange(0,1);
	m_Spin_G.SetRange(0,1);

	UpdateDialog();
	
	return CPropertyPage::OnSetActive();
}
//---------------------------------------------------------------------------
void Tool0::UpdateDialog()
{
	switch (eMethodType)
	{
	case MT_GODUNOV:SetCheck(IDC_RADIO_GOD); break;
	case MT_LW:		SetCheck(IDC_RADIO_LW);  break;
	case MT_HARTEN: SetCheck(IDC_RADIO_HAR); break;
	default: ASSERT(0);
	}

	m_Repaint.SetCheck(bRepaint);
}
//---------------------------------------------------------------------------
void Tool0::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CWnd* sl=pScrollBar;

	UpdateData();

	if (nSBCode!=SB_ENDSCROLL)
	if (sl==&m_Spin_U0)
	{
		switch (nPos)
		{
		case 1:{ U0+=1.;	break;}
		case 0:{ U0-=1.;	break;}
		}
	}
	else if (sl==&m_Spin_P0)
	{
		switch (nPos)
		{
		case 1:{ P0+=1.;	break;}
		case 0:{ P0-=1.;	break;}
		}
	}
	else if (sl==&m_Spin_R0)
	{
		switch (nPos)
		{
		case 1:{ R0+=1.;	break;}
		case 0:{ R0-=1.;	break;}
		}
	}
	else if (sl==&m_Spin_G)
	{
		switch (nPos)
		{
		case 1:{ G+=0.1;	break;}
		case 0:{ G-=0.1;	break;}
		}
	}

	UpdateData(false);
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
//---------------------------------------------------------------------------
void Tool0::SetCheck(UINT idBtn)
{
	static UINT buttons []={IDC_RADIO_GOD, IDC_RADIO_LW, IDC_RADIO_HAR};
/*
	CWnd *pEdit,*pSpin,*pStat;

	pEdit=(CWnd*)GetDlgItem(IDC_EDIT_COEFF_A);
	pSpin=(CWnd*)GetDlgItem(IDC_SPIN_COEFF_A);
	pStat=(CWnd*)GetDlgItem(IDC_STATIC_A);

	pEdit->EnableWindow(TRUE);
	pSpin->EnableWindow(TRUE);
	pStat->EnableWindow(TRUE);
*/
	CButton *pBtn=NULL;

	for(int i=0; i<=2; i++)
	{
		pBtn = (CButton*)GetDlgItem(buttons[i]);
		if(!pBtn) continue;

		if(buttons[i]==idBtn) 
		{
			pBtn->SetCheck(1);
/*
			if ((buttons[0]==idBtn)||(buttons[3]==idBtn))
			{
				pEdit->EnableWindow(FALSE);
				pSpin->EnableWindow(FALSE);
				pStat->EnableWindow(FALSE);
			}
*/
			switch (i)
			{
			case 0: methodTitle.LoadString(IDS_STRING_GOD); break;
			case 1: methodTitle.LoadString(IDS_STRING_LW);  break;
			case 2: methodTitle.LoadString(IDS_STRING_HAR);
			}
		}
		else pBtn->SetCheck(0);
	}
}
//---------------------------------------------------------------------------
void Tool0::OnRadioGod() { SetCheck(IDC_RADIO_GOD);	eMethodType=MT_GODUNOV; }
void Tool0::OnRadioLW()  { SetCheck(IDC_RADIO_LW);	eMethodType=MT_LW;		}
void Tool0::OnRadioHar() { SetCheck(IDC_RADIO_HAR);	eMethodType=MT_HARTEN;	}
//---------------------------------------------------------------------------
