// Tool1.cpp : implementation file
//

#include "stdafx.h"
#include "gasdynamics.h"
#include "Tool1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	double Lx,Ly,Lt,CFL;
extern	int Nx,Ny,Mx,My,Nout;

/////////////////////////////////////////////////////////////////////////////
// Tool1 property page

IMPLEMENT_DYNCREATE(Tool1, CPropertyPage)

Tool1::Tool1() : CPropertyPage(Tool1::IDD)
{
}

void Tool1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SPIN_Ny, m_Spin_Ny);
	DDX_Control(pDX, IDC_SPIN_Nx, m_Spin_Nx);
	DDX_Control(pDX, IDC_SPIN_My, m_Spin_My);
	DDX_Control(pDX, IDC_SPIN_Mx, m_Spin_Mx);
	DDX_Control(pDX, IDC_SPIN_Ly, m_Spin_Ly);
	DDX_Control(pDX, IDC_SPIN_Lx, m_Spin_Lx);
	DDX_Control(pDX, IDC_SPIN_Lt, m_Spin_Lt);
	DDX_Control(pDX, IDC_SPIN_Nout, m_Spin_Nout);
	DDX_Control(pDX, IDC_SPIN_CFL, m_Spin_CFL);

	DDX_Text(pDX, IDC_EDIT_CFL, CFL);
	DDX_Text(pDX, IDC_EDIT_Lt, Lt);
	DDX_Text(pDX, IDC_EDIT_Nout, Nout);
	DDX_Text(pDX, IDC_EDIT_Lx, Lx);
	DDX_Text(pDX, IDC_EDIT_Ly, Ly);
	DDX_Text(pDX, IDC_EDIT_Nx, Nx);
	DDX_Text(pDX, IDC_EDIT_Ny, Ny);
	DDX_Text(pDX, IDC_EDIT_Mx, Mx);
	DDX_Text(pDX, IDC_EDIT_My, My);
}


BEGIN_MESSAGE_MAP(Tool1, CPropertyPage)
	ON_WM_VSCROLL()
	ON_EN_CHANGE(IDC_EDIT_Lx, OnChangeEdit)
	ON_EN_CHANGE(IDC_EDIT_Ly, OnChangeEdit)
	ON_EN_CHANGE(IDC_EDIT_Nx, OnChangeEdit)
	ON_EN_CHANGE(IDC_EDIT_Ny, OnChangeEdit)
	ON_EN_CHANGE(IDC_EDIT_Mx, OnChangeEdit)
	ON_EN_CHANGE(IDC_EDIT_My, OnChangeEdit)
	ON_EN_CHANGE(IDC_EDIT_Lt, OnChangeEdit)
	ON_EN_CHANGE(IDC_EDIT_Nout, OnChangeEdit)
	ON_EN_CHANGE(IDC_EDIT_CFL, OnChangeEdit)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Tool1 message handlers
//---------------------------------------------------------------------------
void Tool1::OnChangeEdit()	{ UpdateData(); chek_values(); }
//---------------------------------------------------------------------------
void Tool1::chek_values()
{
	if (Lx<=0.) Lx=0.1;
	if (Ly<=0.) Ly=0.1;
	if (Nx<1) Nx=1;
	if (Nx>NX_MAX-4) Nx=NX_MAX-4;
	if (Ny<1) Ny=1;
	if (Ny>NY_MAX-5) Ny=NY_MAX-5;
	if (Mx<0)  Mx=0;
	if (Mx>Nx) Mx=Nx;
	if (My<0)  My=0;
	if (My>Ny) My=Ny;
	if (Lt<0.) Lt=0.1;
	if (Nout<2) Nout=2;
	if (CFL<0.) CFL=0.001;
	UpdateData(false);
}
//---------------------------------------------------------------------------
void Tool1::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CWnd* sl=pScrollBar;
	UpdateData();

	if (nSBCode!=SB_ENDSCROLL)
	if (sl==&m_Spin_Lx)
	{
		switch (nPos)
		{
		case 1:{ Lx+=0.1;	break;}
		case 0:{ Lx-=0.1;	break;}
		}
	}
	else if (sl==&m_Spin_Ly)
	{
		switch (nPos)
		{
		case 1:{ Ly+=0.1;	break;}
		case 0:{ Ly-=0.1;	break;}
		}
	}
	else if (sl==&m_Spin_Nx)
	{
		switch (nPos)
		{
		case 1:{ Nx++;	break;}
		case 0:{ Nx--;	break;}
		}
	}
	else if (sl==&m_Spin_Ny)
	{
		switch (nPos)
		{
		case 1:{ Ny++;	break;}
		case 0:{ Ny--;	break;}
		}
	}
	else if (sl==&m_Spin_Mx)
	{
		switch (nPos)
		{
		case 1:{ Mx++;	break;}
		case 0:{ Mx--;	break;}
		}
	}
	else if (sl==&m_Spin_My)
	{
		switch (nPos)
		{
		case 1:{ My++;	break;}
		case 0:{ My--;	break;}
		}
	}
	else if (sl==&m_Spin_Lt)
	{
		switch (nPos)
		{
		case 1:{ Lt+=0.1;	break;}
		case 0:{ Lt-=0.1;	break;}
		}
	}
	else if (sl==&m_Spin_Nout)
	{
		switch (nPos)
		{
		case 1:{ Nout++;	break;}
		case 0:{ Nout--;	break;}
		}
	}
	else if (sl==&m_Spin_CFL)
	{
		switch (nPos)
		{
		case 1:{ CFL+=0.1;	break;}
		case 0:{ CFL-=0.1;	break;}
		}
	}
	chek_values();

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
//---------------------------------------------------------------------------
BOOL Tool1::OnSetActive() 
{
	m_Spin_Lx.SetRange(0,1);
	m_Spin_Ly.SetRange(0,1);
	m_Spin_Nx.SetRange(0,1);
	m_Spin_Ny.SetRange(0,1);
	m_Spin_Mx.SetRange(0,1);
	m_Spin_My.SetRange(0,1);
	m_Spin_Lt.SetRange(0,1);
	m_Spin_Nout.SetRange(0,1);
	m_Spin_CFL.SetRange(0,1);
	
	return CPropertyPage::OnSetActive();
}
//---------------------------------------------------------------------------
