///////////////////////////////////////////////////////////////////////////////
//
//           
//  ""   .
//
//-----------------------------------------------------------------------------
//
//	,  :
//
//  -   "stereo"      
//	-     (     )
//  -   3D  ,        
//  -         
//      :
//	  -   PixBox
//    -     MainFrame
//    -  
//    -   MainFrame     
//
//=============================================================================
//
//	Data.cpp : implementation file
//

#include "stdafx.h"
#include "Gasdynamics.h"
#include "Data.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

	extern int	mNx,mNy; //  
	extern int		mask[NX_MAX][NY_MAX];
	extern double	matrix[NF][NX_MAX][NY_MAX];

	extern double U1[4][NX_MAX][NY_MAX];
	extern double V[4][NX_MAX];
	extern double F[4][NX_MAX], P[NX_MAX];
	extern double D[4][NX_MAX], Dg[4][NX_MAX], A[4][NX_MAX], B[4][NX_MAX], R[4][4][NX_MAX];

	extern double Vgas[4];
	extern double Hx,Hy,Hmin,CFL;
	extern double G,G0,G1,G2,G3,G4,G5,G6,G7,G8,G9,G10,G11,G12;
	extern double U0,P0,R0,E0,Ce,Uchap,Utest,Ptest,Rtest,Etest;
	extern double Time, Lx,Ly,Lt,Lt0;
	extern int Nx,Ny,Mx,My,Jt,Nout, KeyOut;
	extern int Nx_,Ny_,Mx_,My_,iOut;

	extern METHOD_TYPE eMethodType;

	extern BOOL bRunRequest, bInitCalculations, bRepaint;

/////////////////////////////////////////////////////////////////////////////
// Data

IMPLEMENT_DYNCREATE(Data, CWinThread)

Data::Data()
{
}

BEGIN_MESSAGE_MAP(Data, CWinThread)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Data message handlers
//---------------------------------------------------------------------------
BOOL Data::InitInstance()
{
M1:	do
	{
//TRACE0("\nData -0-");
		bool bUpdate = false;
		if (bInitCalculations)
		{
			((CMainFrame*)pParent)->InitCalculations();
			bInitCalculations = false;
			bUpdate = true;
			bRunRequest =false;
			ResetEvent(((CMainFrame*)pParent)->m_hRunRequest);
		}
		if (bRepaint)
		{
			((CMainFrame*)pParent)->Show();
			bRepaint = false;
			bUpdate = true;
			if (!bRunRequest)
			ResetEvent(((CMainFrame*)pParent)->m_hRunRequest);
		}
		if (bUpdate || !bRunRequest)
		{
			((CMainFrame*)pParent)->UpdateTitle();
			((CMainFrame*)pParent)->bTitle = false;
			((CMainFrame*)pParent)->Show();
		}

		WaitForSingleObject(((CMainFrame*)pParent)->m_hRunRequest, INFINITE);

		Jt++;
//-- X ------
		Inject(0,1, 0, Ny_+2,Vgas[0],Vgas[1],Vgas[2],Vgas[3]);
		Def_Ht();
		Free_X(My_+1,Ny_,Nx_,DUMMY_AT_RIGHT);

if (eMethodType == MT_HARTEN)
		Inject(Nx_,Nx_+1, My_+1,Ny_+2,Vgas[0],Vgas[1],Vgas[2],Vgas[3]);

		Wall_X(2,    My_,Mx_,DUMMY_AT_RIGHT, WALL_BETWEEN_MESH_POINTS);

		Proc_X(2,Mx_,2,    My_);
		Proc_X(2,Nx_,My_+1,Ny_);
//-- Y ------
		Wall_Y(2    ,Nx_,  Ny_,  DUMMY_AT_TOP,	  WALL_BETWEEN_MESH_POINTS);
		Wall_Y(2    ,Mx_+2,2,    DUMMY_AT_BOTTOM, WALL_BETWEEN_MESH_POINTS);
		Wall_Y(Mx_+1,Nx_,  My_+1,DUMMY_AT_BOTTOM, WALL_BETWEEN_MESH_POINTS);

		Proc_Y(2    ,Mx_,2,    Ny_);
		Proc_Y(Mx_+1,Nx_,My_+1,Ny_);
		
		Time += Ht;

//	       
		//if ( bRunRequest && !((CMainFrame*)pParent)->bTitle )
		if ( !((CMainFrame*)pParent)->bTitle )
		{
			((CMainFrame*)pParent)->bTitle = TRUE;
			((CMainFrame*)pParent)->PostMessage(PM_TITLE,0,0L);
		}

		double Tout = Lt0 + (Lt - Lt0)*iOut/Nout;
		if ( (Tout > (Time-Ht)) && (Tout <= Time) )
		{	
			if (!(((CMainFrame*)pParent)->bExecuteOnButtonPaint))
			//     , 
			//       "Re"
			{
			//    X
				Inject(0,1, 0, Ny_+2,Vgas[0],Vgas[1],Vgas[2],Vgas[3]);
				Free_X(My_+1,Ny_,Nx_,DUMMY_AT_RIGHT);

			if (eMethodType == MT_HARTEN)
				Inject(Nx_,Nx_+1, My_+1,Ny_+2,Vgas[0],Vgas[1],Vgas[2],Vgas[3]);
			//    Y
				Wall_Y(2    ,Nx_,  Ny_,  DUMMY_AT_TOP,	  WALL_BETWEEN_MESH_POINTS);
				Wall_Y(2    ,Mx_+2,2,    DUMMY_AT_BOTTOM, WALL_BETWEEN_MESH_POINTS);
				Wall_Y(Mx_+1,Nx_,  My_+1,DUMMY_AT_BOTTOM, WALL_BETWEEN_MESH_POINTS);


				iOut++;

				if (bRunRequest) 
				((CMainFrame*)pParent)->Show();
			}
		}
	} while (Time<=Lt);

	bRunRequest = false;
	ResetEvent(((CMainFrame*)pParent)->m_hRunRequest);

	(((CMainFrame*)pParent)->m_wndToolBar.GetToolBarCtrl()).CheckButton(ID_BUTTON_PAUSE, TRUE);

	if (bRunRequest) ((CMainFrame*)pParent)->Show();
	WaitForSingleObject(((CMainFrame*)pParent)->m_hRunRequest, INFINITE);

	goto M1;

	return TRUE;
}
//---------------------------------------------------------------------------
void Data::Def_Ht()
{
//       
//    -- CFL

	int x,y;

	if (CFL > 0.)
	{
		Od = 0.;

		for (y=2; y<=Ny_; y++)
		for (x=2; x<=Nx_; x++)
		{
			Oa = U1[0][x][y];
			Ob = U1[1][x][y]/Oa;
			Oc = U1[2][x][y]/Oa;
			Oc = Ob*Ob + Oc*Oc;
			Oa = G*G1*(U1[3][x][y]/Oa - Oc*0.5);

			if (Oa>0.) Oa = sqrt(Oa);
			else	   Oa = 0.;

			Oa += sqrt(Oc);
			if (Od <= Oa) Od = Oa;
		}
		Ht = Hmin*CFL/Od;
	}
	HtHx = Ht/Hx;
	HtHy = Ht/Hy;
}
//---------------------------------------------------------------------------
void Data::Free_X(int Ymin,int Ymax,int x, DUMMY_BORDER_POS border_pos)
{
//    ,   X
//		border_pos=DUMMY_AT_RIGHT -  ""
//				  =DUMMY_AT_LEFT  -  ""
//		x -  

	int  y,k,x1,x2;
	
	switch (border_pos)
	{
	case DUMMY_AT_LEFT:	{ x1 = x-1; x2 = x-2; Oc = -Hx/Ht;} break;
	case DUMMY_AT_RIGHT:{ x1 = x+1; x2 = x+2; Oc = Hx/Ht; } break;
	default: ASSERT(0);
	}

	for (y=Ymin; y<=Ymax; y++)
	{
		Oa = U1[1][x][y];
		Ob = U1[0][x][y];


		Oe = U1[1][x][y]/U1[0][x][y];
		if (((Oe>0.) && (border_pos == DUMMY_AT_LEFT)) || ((Oe<0.) && (border_pos == DUMMY_AT_RIGHT)))
		{
			Error.Format("  Free_X:     .\n[x,y]=[%i,%i]  border_pos=%i,  Ux=%e\n\n", x,y,border_pos,Oe);
			AfxMessageBox(Error);

			ASSERT(0);
			ExitThread(0);
		}
		Oa = U1[1][x2][y]/U1[0][x2][y];
		Od = Oa/(Oa - U1[1][x1][y]/U1[0][x1][y] + Oc);
		Ob = 1. - Od;

		for (k = 0; k<= 3; k++) U1[k][x2][y] = U1[k][x2][y]*Od + U1[k][x1][y]*Ob;

		Oa = U1[1][x1][y]/U1[0][x1][y];
		Od = Oa/(Oa - Oe + Oc);
		Ob = 1. - Od;

		for (k=0; k<=3; k++) U1[k][x1][y] = U1[k][x1][y]*Od + U1[k][x][y]*Ob;
	}
}
//---------------------------------------------------------------------------
void Data::Wall_X(int Ymin,int Ymax,int x, 
				  DUMMY_BORDER_POS border_pos,
				  WALL_BORDER_POS  wall_pos)
{
//	  ,   X
//		border_pos=DUMMY_AT_RIGHT -  ""
//				  =DUMMY_AT_LEFT  -  ""
//		x -       
//				wall_pos=WALL_BETWEEN_MESH_POINTS(     )
//			     
//				wall_pos=WALL_AT_MESH_POINT		(    )

	int y,J1,J2;
	
	switch (border_pos)
	{
	case DUMMY_AT_LEFT:	{ J1=-1; J2=-2; } break;
	case DUMMY_AT_RIGHT:{ J1=1;  J2=2;  } break;
	default: ASSERT(0);
	}

	switch (wall_pos)
	{
	case WALL_BETWEEN_MESH_POINTS:
		for (y=Ymin; y<=Ymax; y++)
		{
			U1[0][x+J1][y] = U1[0][x][y];
			U1[1][x+J1][y] = -U1[1][x][y];
			U1[2][x+J1][y] = U1[2][x][y];
			U1[3][x+J1][y] = U1[3][x][y];

			U1[0][x+J2][y] = U1[0][x-J1][y];
			U1[1][x+J2][y] = -U1[1][x-J1][y];
			U1[2][x+J2][y] = U1[2][x-J1][y];
			U1[3][x+J2][y] = U1[3][x-J1][y];
		}	break;
	case WALL_AT_MESH_POINT:
		for (y=Ymin; y<=Ymax; y++)
		{
			U1[0][x+J1][y] = U1[0][x-J1][y];
			U1[1][x+J1][y] = -U1[1][x-J1][y];
			U1[2][x+J1][y] = U1[2][x-J1][y];
			U1[3][x+J1][y] = U1[3][x-J1][y];

			U1[0][x+J2][y] = U1[0][x-J2][y];
			U1[1][x+J2][y] = -U1[1][x-J2][y];
			U1[2][x+J2][y] = U1[2][x-J2][y];
			U1[3][x+J2][y] = U1[3][x-J2][y];
		}	break;
	default: ASSERT(0);
	}
}
//---------------------------------------------------------------------------
void Data::Wall_Y(int Xmin,int Xmax,int y,
				  DUMMY_BORDER_POS border_pos,
  				  WALL_BORDER_POS  wall_pos)
{
//	  ,   Y
//		border_pos=DUMMY_AT_TOP	   -  ""
//				  =DUMMY_AT_BOTTOM -  ""
//		y -       
//				wall_pos=WALL_BETWEEN_MESH_POINTS(     )
//			     
//				wall_pos=WALL_AT_MESH_POINT		(    )

	int x, J1,J2;

	switch (border_pos)
	{
	case DUMMY_AT_BOTTOM: { J1=-1; J2=-2; } break;
	case DUMMY_AT_TOP:	  { J1=1;  J2=2;  } break;
	default: ASSERT(0);
	}


	switch (wall_pos)
	{
	case WALL_BETWEEN_MESH_POINTS:
		for (x=Xmin; x<=Xmax; x++)
		{
			U1[0][x][y+J1] = U1[0][x][y];
			U1[1][x][y+J1] = U1[1][x][y];
			U1[2][x][y+J1] = -U1[2][x][y];
			U1[3][x][y+J1] = U1[3][x][y];

			U1[0][x][y+J2] = U1[0][x][y-J1];
			U1[1][x][y+J2] = U1[1][x][y-J1];
			U1[2][x][y+J2] = -U1[2][x][y-J1];
			U1[3][x][y+J2] = U1[3][x][y-J1];
		}	break;
	case WALL_AT_MESH_POINT:
		for (x=Xmin; x<=Xmax; x++)
		{
			U1[0][x][y+J1] = U1[0][x][y-J1];
			U1[1][x][y+J1] = U1[1][x][y-J1];
			U1[2][x][y+J1] = -U1[2][x][y-J1];
			U1[3][x][y+J1] = U1[3][x][y-J1];

			U1[0][x][y+J2] = U1[0][x][y-J2];
			U1[1][x][y+J2] = U1[1][x][y-J2];
			U1[2][x][y+J2] = -U1[2][x][y-J2];
			U1[3][x][y+J2] = U1[3][x][y-J2];
		}	break;
	default: ASSERT(0);
	}
}
//---------------------------------------------------------------------------
void Data::Inject(int x1,int x2,int y1,int y2,
				  double O1,double O2,double O3,double O4)
{
//	    
	int x,y;

	for (y=y1; y<=y2; y++)
	for (x=x1; x<=x2; x++)
	{
		U1[0][x][y] = O1;
		U1[1][x][y] = O2;
		U1[2][x][y] = O3;
		U1[3][x][y] = O4;
	}
}
//---------------------------------------------------------------------------
void Data::LW_X(int Xmin,int Xmax, int Ymin,int Ymax)
{
//      -
//    X (   )
	int x,y,k;

	for (y=Ymin; y<=Ymax; y++)
	{
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		for (x=Xmin-1; x<=Xmax+1; x++)
		{
			F[0][x] = U1[1][x][y];
			F[1][x] = G1*U1[3][x][y] + (G3*U1[1][x][y]*U1[1][x][y] -
					  G2*U1[2][x][y]*U1[2][x][y])/U1[0][x][y];
			F[2][x] = U1[1][x][y]*U1[2][x][y]/U1[0][x][y];
			F[3][x] = (G*U1[1][x][y]*U1[3][x][y] -
				G2*U1[1][x][y]*(U1[1][x][y]*U1[1][x][y] + U1[2][x][y]*U1[2][x][y])/
				U1[0][x][y])/U1[0][x][y];
		}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		for (x=Xmin-1; x<=Xmax; x++)
		for (k=0; k<=3; k++)
			V[k][x] = (U1[k][x+1][y] + U1[k][x][y] - HtHx*(F[k][x+1] - F[k][x]))*0.5;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		for (x=Xmin-1; x<=Xmax; x++)
		{
			F[0][x] = V[1][x];
			F[1][x] = G1*V[3][x] + (G3*V[1][x]*V[1][x] - G2*V[2][x]*V[2][x])/V[0][x];
			F[2][x] = V[1][x]*V[2][x]/V[0][x];
			F[3][x] = (G*V[1][x]*V[3][x] -
					  G2*V[1][x]*(V[1][x]*V[1][x] + V[2][x]*V[2][x])/V[0][x])/V[0][x];

			Oa = Ce*__max((double)0.,(double)(U1[1][x][y]/U1[0][x][y]-
				U1[1][x+1][y]/U1[0][x+1][y] +
				(U1[2][x][y-1]/U1[0][x][y-1] - U1[2][x][y+1]/U1[0][x][y+1]) +
				(U1[2][x+1][y-1]/U1[0][x+1][y-1] - U1[2][x+1][y+1]/U1[0][x+1][y+1])*0.25));

			for (k=0; k<=3; k++)
				F[k][x] += Oa*(U1[k][x][y] - U1[k][x+1][y]);
		}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		for (x=Xmin; x<=Xmax; x++)
		for (k=0; k<=3; k++)
			U1[k][x][y] -= HtHx*(F[k][x] - F[k][x-1]);
	}
}
//---------------------------------------------------------------------------
void Data::LW_Y(int Xmin,int Xmax, int Ymin,int Ymax)
{	
//      -
//    Y (   )
	int x,y,k;

	for (x=Xmin; x<=Xmax; x++)
	{
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		for (y=Ymin-1; y<=Ymax+1; y++)
		{
			F[0][y] = U1[2][x][y];
			F[1][y] = U1[1][x][y]*U1[2][x][y]/U1[0][x][y];
			F[2][y] = G1*U1[3][x][y] + (G3*U1[2][x][y]*U1[2][x][y] -
					  G2*U1[1][x][y]*U1[1][x][y])/U1[0][x][y];
			F[3][y] = (G*U1[2][x][y]*U1[3][x][y] - G2*U1[2][x][y]*
				(U1[2][x][y]*U1[2][x][y] + U1[1][x][y]*U1[1][x][y])/
				U1[0][x][y])/U1[0][x][y];
		}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		for (y=Ymin-1; y<=Ymax; y++)
		for (k=0; k<=3; k++)
			V[k][y] = (U1[k][x][y+1] + U1[k][x][y] - HtHy*(F[k][y+1] - F[k][y]))*0.5;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		for (y=Ymin-1; y<=Ymax; y++)
		{
			F[0][y] = V[2][y];
			F[1][y] = V[1][y]*V[2][y]/V[0][y];
			F[2][y] = G1*V[3][y] + (G3*V[2][y]*V[2][y] - G2*V[1][y]*V[1][y])/V[0][y];
			F[3][y] = (G*V[2][y]*V[3][y] -
				G2*V[2][y]*(V[2][y]*V[2][y] + V[1][y]*V[1][y])/V[0][y])/V[0][y];

			Oa = Ce*__max((double)0.,(double)(U1[2][x][y]/U1[0][x][y] -
				U1[2][x][y+1]/U1[0][x][y+1] +
			(U1[1][x-1][y]/U1[0][x-1][y] - U1[1][x+1][y]/U1[0][x+1][y]) +
			(U1[1][x-1][y+1]/U1[0][x-1][y+1] - U1[1][x+1][y+1]/U1[0][x+1][y+1])*0.25));

			for (k=0; k<=3; k++)
				F[k][y] += Oa*(U1[k][x][y] - U1[k][x][y+1]);
		}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		for (y=Ymin; y<=Ymax; y++)
		for (k=0; k<=3; k++)
			U1[k][x][y] -= HtHy*(F[k][y] - F[k][y-1]);
	}
}
//---------------------------------------------------------------------------
/*
void Data::FillMatrix()
{
//   matrix    : (R,Ux,Uy,E,P,H,|U|,M,S)

	int x,y,k;
	double U,V;
	double A[NF];

//    X
	Inject(0,1, 0, Ny_+2,Vgas[0],Vgas[1],Vgas[2],Vgas[3]);
	Free_X(My_+1,Ny_,Nx_,DUMMY_AT_RIGHT);

if (eMethodType==MT_HARTEN)
	Inject(Nx_,Nx_+1, My_+1,Ny_+2,Vgas[0],Vgas[1],Vgas[2],Vgas[3]);
//    Y
	Wall_Y(2    ,Nx_,  Ny_,  DUMMY_AT_TOP,	  WALL_BETWEEN_MESH_POINTS);
	Wall_Y(2    ,Mx_+2,2,    DUMMY_AT_BOTTOM, WALL_BETWEEN_MESH_POINTS);
	Wall_Y(Mx_+1,Nx_,  My_+1,DUMMY_AT_BOTTOM, WALL_BETWEEN_MESH_POINTS);

// - - - - - - - - - - - - -
	for (y=mNy; y>=0;	y--)
	for (x=0;	x<=mNx; x++)
	{
	//	if (IsInGas(x,y))
		if (mask[x][y])
		{
		//RPEMHSU
			A[0]=U1[0][x][y];			// R
				U=U1[1][x][y]/A[0];
				V=U1[2][x][y]/A[0];
			A[7]=U;						// Ux
			A[8]=V;						// Uy
				U=U*U+V*V;
				V=U1[3][x][y]/A[0];
			A[2]=V-0.5*U;				// E
			A[1]=A[0]*A[2]*(G-1.);		// P
			A[4]=G*V-(G-1.)*0.5*U;		// H
				V=(G-1.)*(A[4]-U*0.5);
			A[6]=sqrt(U);				//|U|
			A[3]=sqrt(U/V);				// M
			A[5]=A[1]*exp(-G*log(A[0]));// S
   
			for (k=0; k<NF; k++) matrix[k][x][y]=A[k];
		}
		else for (k=0; k<NF; k++) matrix[k][x][y]=0;
	}
}
*/
//---------------------------------------------------------------------------
void Data::FFp(double P,double Pk,double Rk,
			   double* F,double* Fp)
{
	if (P>=Pk)
	{
		*F = (P - Pk)/sqrt(Rk*(G4*P + G2*Pk));
		*Fp = (P + G7*Pk)/(sqrt(Rk*(G0*P + G9*Pk))*(P + G6*Pk));
	}
	else
	{
		Oe = sqrt(G*Pk/Rk);
			*Fp = pow(P/Pk,G5);
		*F = Oe*(*Fp-1.)/G2;
		*Fp = Oe*(*Fp)/(G*P);
	}
}
//---------------------------------------------------------------------------
void Data::Rarefaction(double Pr,double Rr,double Ur,
					   double* P,double* R,double* U)
{
	*U = Ur*G6-sqrt(G*Pr/Rr)/G4;
		*P = Pr/pow(Rr,G);
	*R = pow((*U)*(*U)/(G*(*P)),G11);
	*P = *P*pow((*R),G);
}
//---------------------------------------------------------------------------
void Data::Proc_X(int Xmin, int Xmax, int Ymin, int Ymax)
{
	switch (eMethodType)
	{
	case MT_GODUNOV: God_X(Xmin,Xmax,Ymin,Ymax);	break;
	case MT_LW:		 LW_X(Xmin,Xmax,Ymin,Ymax);		break;
	case MT_HARTEN:	 Har_X(Xmin,Xmax,Ymin,Ymax);	break;
	}
}
//---------------------------------------------------------------------------
void Data::Proc_Y(int Xmin, int Xmax, int Ymin, int Ymax)
{
	switch (eMethodType)
	{
	case MT_GODUNOV: God_Y(Xmin,Xmax,Ymin,Ymax);	break;
	case MT_LW:		 LW_Y(Xmin,Xmax,Ymin,Ymax);		break;
	case MT_HARTEN:	 Har_Y(Xmin,Xmax,Ymin,Ymax);	break;
	}
}
//---------------------------------------------------------------------------
void Data::God_X(int Xmin,int Xmax, int Ymin,int Ymax)
{
//      
//    X (   )

	int iter,x,y,k;
	double F[4][NX_MAX],R[NX_MAX],U[NX_MAX],V[NX_MAX],P[NX_MAX];
	double Pr,Rr,Ur,Vr;

	for (y=Ymin;  y<=Ymax; y++)
	{
		for (x=Xmin-1; x<=Xmax+1; x++)
		{
			R[x] = U1[0][x][y];
			U[x] = U1[1][x][y]/U1[0][x][y];
			V[x] = U1[2][x][y]/U1[0][x][y];
			P[x] = G1*(U1[3][x][y] - (U1[1][x][y]*U1[1][x][y] + U1[2][x][y]*U1[2][x][y])/(2*U1[0][x][y]));
		}

		for (x=Xmin-1; x<=Xmax; x++)
		{
			Riemann(P[x],R[x],U[x], P[x+1],R[x+1],U[x+1],&Pr,&Rr,&Ur, &iter);

			if (iter >= 100)
			{
				s.Format("  God_X:  Jt=%i x=%i  y=%i\n Riemann    100",Jt,x,y);
				Error=Error+s;
				AfxMessageBox(Error);
				exit(0);
			}

			if (Ur<0.) Vr = V[x+1];
			else	   Vr = V[x];

			F[0][x] = Rr*Ur;
			F[1][x] = Pr + Ur*F[0][x];
			F[2][x] = Rr*Ur*Vr;
			F[3][x] = Ur*(Pr*G10 + (Ur*Ur + Vr*Vr)*0.5*Rr);
		}

		for (k=0; k<=3; k++)
		for (x=Xmin; x<=Xmax; x++)
			U1[k][x][y] -= HtHx*(F[k][x] - F[k][x-1]);
	}
}
//---------------------------------------------------------------------------
void Data::God_Y(int Xmin,int Xmax, int Ymin,int Ymax)
{
//      
//    Y (   )

	int iter,x,y,k;
	double F[4][NY_MAX],R[NY_MAX],U[NY_MAX],V[NY_MAX],P[NY_MAX];
	double Pr,Rr,Ur,Vr;

	for (x=Xmin; x<=Xmax; x++)
	{
		for (y=Ymin-1; y<=Ymax+1; y++)
		{
			R[y] = U1[0][x][y];
			U[y] = U1[1][x][y]/U1[0][x][y];
			V[y] = U1[2][x][y]/U1[0][x][y];
			P[y] = G1*(U1[3][x][y] - (U1[1][x][y]*U1[1][x][y] + U1[2][x][y]*U1[2][x][y])/(2*U1[0][x][y]));
		}

		for (y=Ymin-1; y<=Ymax; y++)
		{
			Riemann(P[y],R[y],V[y], P[y+1],R[y+1],V[y+1],&Pr,&Rr,&Vr, &iter);

			if (iter >= 100)
			{
				s.Format("  God_Y:  Jt=%i x=%i  y=%i\n Riemann    100",Jt,x,y);
				Error += s;
				AfxMessageBox(Error);
				exit(0);
			}

			if (Vr<0.) Ur = U[y+1];
			else	   Ur = U[y];

			F[0][y] = Rr*Vr;
			F[1][y] = Rr*Vr*Ur;
			F[2][y] = Pr + Vr*F[0][y];
			F[3][y] = Vr*(Pr*G10 + (Vr*Vr + Ur*Ur)*0.5*Rr);
		}

		for (k=0; k<=3; k++)
		for (y=Ymin; y<=Ymax; y++)
			U1[k][x][y] -= HtHy*(F[k][y] - F[k][y-1]);
      }
}
//---------------------------------------------------------------------------
void Data::Har_X(int Xmin,int Xmax, int Ymin,int Ymax)
{
//      
//    X (   )

	int x,y,k,m;
	double U,C,O,Oa,Ob,Oc,Od,Oe, O1,O2,O3,O4;
	const double tine = 0.;

for (y=Ymin; y<=Ymax; y++)
{
	for (k=0; k<=3; k++)
	for (x=Xmin-2; x<=Xmax+2; x++) V[k][x] = U1[k][x][y];

	O2 = V[1][Xmin-2]/V[0][Xmin-2];
	O4 = V[2][Xmin-2]/V[0][Xmin-2];

	for (x=Xmin-2; x<=Xmax+1; x++)
	{
		Oa = sqrt(V[0][x+1]/V[0][x]);
		O = Oa + 1.;
		O1 = V[1][x+1]/V[0][x+1];
		O3 = V[2][x+1]/V[0][x+1];
		U = (O1*Oa + O2)/O;
		Oe = (O3*Oa + O4)/O;
		Od = Oe*Oe;
		Oc = (G*(V[3][x+1]*Oa/V[0][x+1] + V[3][x]/V[0][x]) - G2*((O1*O1 + O3*O3)*Oa + O2*O2 + O4*O4))/O;
		O2 = O1;
		O4 = O3;
		Od = 0.5*(U*U + Od);
		O = G1*(Oc - Od);

		if (O <= 0.)
		{
			s.Format("  HarX:       :\n"
				"Jt=%i x=%i y=%i O=%g (O<=0)\n\n"
				"    ,    (CFL)",
				Jt,x,y,O);
			AfxMessageBox(s);
			exit(0);
		}
		C = sqrt(O);
		Oa = G1*(V[3][x+1] - V[3][x] + 
			 Od*(V[0][x+1] - V[0][x]) - U*(V[1][x+1] - V[1][x]) - Oe*(V[2][x+1] - V[2][x]))/O;

		Ob = (V[1][x+1] - V[1][x] - U*(V[0][x+1] - V[0][x]))/C;

		A[0][x] = (Oa - Ob)/2.;
		A[1][x] = V[0][x+1] - V[0][x] - Oa;
		A[2][x] = (Oa + Ob)/2.;
		A[3][x] = V[2][x+1] - V[2][x] - Oe*(V[0][x+1] - V[0][x]);
	R[1][0][x] = U - C;
	R[1][1][x] = U;
	R[1][2][x] = U + C;
	R[1][3][x] = 0.;
		R[2][0][x] = Oe;
		R[2][1][x] = Oe;
		R[2][2][x] = Oe;
		R[2][3][x] = 1.;
	R[3][0][x] = Oc - U*C;
	R[3][1][x] = Od;
	R[3][2][x] = Oc + U*C;
	R[3][3][x] = Oe;
		B[0][x] = HtHx*(U - C);
		B[1][x] = HtHx*U;
		B[2][x] = HtHx*(U + C);
		B[3][x] = B[1][x];
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
	for (k=0; k<=3; k++)
	for (x=Xmin-1; x<=Xmax+1; x++)
	{
		if (A[k][x] > 0.)
		{
			m = 1;
			Ob = A[k][x-1];
		}
		else
		{
			m = -1;
			Ob = -A[k][x-1];
		}

		Oa = fabs(A[k][x]);

		if (Oa>Ob) Oa = Ob;
		if (Oa<0.) Oa = 0.;

		if (m>0) D[k][x] = Oa;
		else	 D[k][x] = -Oa;
	}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
	for (k=0; k<=3; k++)
	for (x=Xmin-1; x<=Xmax; x++)
	{
		if (fabs(A[k][x])>tine) O = (D[k][x+1] - D[k][x])/A[k][x];
		else					O = 0.;

		Oa = B[k][x] + O*0.125;
		Ob = (Oa*Oa + 0.25)*A[k][x];
		Dg[k][x] = (D[k][x+1] + D[k][x])*0.125 - Ob;
	}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
	for (x=Xmin-1; x<Xmax; x++)
	{
		F[0][x] = V[1][x];
		F[1][x] = G1*V[3][x] + (G3*V[1][x]*V[1][x] - G2*V[2][x]*V[2][x])/V[0][x];
		F[2][x] = V[1][x]*V[2][x]/V[0][x];
		F[3][x] = (G*V[1][x]*V[3][x] - G2*V[1][x]*(V[1][x]*V[1][x] + V[2][x]*V[2][x])/V[0][x])/V[0][x];
	}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
	for (k=0; k<=3; k++)
	for (x=Xmin-1; x<=Xmax; x++)
	{
		O=0.;
		for (m=0; m<=3; m++)
			O += R[k][m][x]*Dg[m][x];
		D[k][x] = O;
	}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
	for (x=Xmin; x<=Xmax; x++)
	for (k=0; k<=3; k++)
		U1[k][x][y] = V[k][x] - 0.5*(HtHx*(F[k][x+1] - F[k][x-1]) + D[k][x] - D[k][x-1]);
}
}
//---------------------------------------------------------------------------
void Data::Har_Y(int Xmin,int Xmax, int Ymin,int Ymax)
{
//      
//    Y (   )

	int x,y,k,m;
	double U,C,O,Oa,Ob,Oc,Od,Oe, O1,O2,O3,O4;
	const double tine=0.;

	for (x=Xmin; x<=Xmax; x++)
	{
		for (k=0; k<=3; k++)
		for (y=Ymin-2; y<=Ymax+2; y++)  V[k][y] = U1[k][x][y];

		O2 = V[2][Ymin-2]/V[0][Ymin-2];
		O4 = V[1][Ymin-2]/V[0][Ymin-2];

		for (y=Ymin-2; y<=Ymax+1; y++)
		{
			Oa = sqrt(V[0][y+1]/V[0][y]);
			O1 = V[2][y+1]/V[0][y+1];
			O3 = V[1][y+1]/V[0][y+1];
			O = Oa + 1.;
			U = (O1*Oa + O2)/O;
			Oe = (O3*Oa + O4)/O;
			Od = Oe*Oe;
			Oc = (G*(V[3][y+1]*Oa/V[0][y+1] + V[3][y]/V[0][y]) - G2*((O1*O1 + O3*O3)*Oa + O2*O2 + O4*O4))/O;
			Od = 0.5*(U*U + Od);
			O2 = O1;
			O4 = O3;
			O = G1*(Oc - Od);

			if (O <= 0.)
			{
				s.Format("  HarY:       :\n"
					"Jt=%i x=%i y=%i O=%g (O<=0)\n\n"
					"    ,    (CFL)",
					Jt,x,y,O);
				AfxMessageBox(s);
				exit(0);
			}
			C = sqrt(O);
			Oa = G1*(V[3][y+1] - V[3][y] + Od*
				 (V[0][y+1] - V[0][y]) - U*(V[2][y+1] - V[2][y]) - Oe*(V[1][y+1] - V[1][y]))/O;
			Ob = (V[2][y+1] - V[2][y] - U*(V[0][y+1] - V[0][y]))/C;

			A[0][y] = (Oa-Ob)/2.;
			A[1][y] = V[0][y+1] - V[0][y] - Oa;
			A[2][y] = (Oa+Ob)/2.;
			A[3][y] = V[1][y+1] - V[1][y] - Oe*(V[0][y+1]-V[0][y]);
		R[1][0][y] = Oe;
		R[1][1][y] = Oe;
		R[1][2][y] = Oe;
		R[1][3][y] = 1.;
			R[2][0][y] = U - C;
			R[2][1][y] = U;
			R[2][2][y] = U + C;
			R[2][3][y] = 0.;
		R[3][0][y] = Oc - U*C;
		R[3][1][y] = Od;
		R[3][2][y] = Oc + U*C;
		R[3][3][y] = Oe;
			B[0][y] = HtHy*(U - C);
			B[1][y] = HtHy*U;
			B[2][y] = HtHy*(U + C);
			B[3][y] = B[1][y];
	}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
		for (k=0; k<=3; k++)
		for (y=Ymin-1; y<=Ymax+1; y++)
		{
			if (A[k][y]>0.)
			{
				m = 1;
				Ob = A[k][y-1];
			}
			else
			{
				m = -1;
				Ob = -A[k][y-1];
			}

			Oa = fabs(A[k][y]);

			if (Oa>Ob)  Oa = Ob;

			if (Oa<0.)  Oa = 0.;

			if  (m>0) D[k][y] = Oa;
			else D[k][y] = -Oa;
		}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
		for (k=0; k<=3; k++)
		for (y=Ymin-1; y<=Ymax; y++)
		{
			if (fabs(A[k][y])>tine) O = (D[k][y+1] - D[k][y])/A[k][y];
			else					O = 0.;

			Oa = B[k][y]+O*0.125;
			Ob = (Oa*Oa+0.25)*A[k][y];
			Dg[k][y] = (D[k][y+1] + D[k][y])*0.125-Ob;
		}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
		for (y=Ymin-1; y<=Ymax+1; y++)
		{
			F[0][y] = V[2][y];
			F[1][y] = V[1][y]*V[2][y]/V[0][y];
			F[2][y] = G1*V[3][y] + (G3*V[2][y]*V[2][y] - G2*V[1][y]*V[1][y])/V[0][y];
			F[3][y] = (G*V[2][y]*V[3][y] - G2*V[2][y]*(V[2][y]*V[2][y] + V[1][y]*V[1][y])/V[0][y])/V[0][y];
		}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
		for (k=0; k<=3; k++)
		for (y=Ymin-1; y<=Ymax; y++)
		{
			O = 0.;
			for (m=0; m<=3; m++) O += R[k][m][y]*Dg[m][y];
			D[k][y] = O;
		}
	//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
		for (y=Ymin; y<=Ymax; y++)
		for (k=0; k<=3; k++)
			U1[k][x][y] = V[k][y] - 0.5*(HtHy*(F[k][y+1] - F[k][y-1]) + D[k][y] - D[k][y-1]);
	}
}
//---------------------------------------------------------------------------
void Data::Riemann(double Pl, double Rl, double Ul,
				   double Pr, double Rr, double Ur,
				   double* Pc,double* Rc,double* Uc, int* iter)
{
//	    
//
//	Left  -  ,  ,
//	Right -  ,  .
//	 : 'S' -   (shock wave)
//			   'R' -   (rarefaction wave)

	BOOL bInvert;
	char Left,Right;
	double	P1,U1,R1, P2,U2,R2, Ushock,Urare,Uvac;
	double Oz,Oa,Ob,Oc,Od,P00;
// - - - - - - - - - - - Ushock Urare Uvac - - - - - - - - - - - - - - -
	if (Pr >= Pl)
	{
		bInvert = false;
		P1 = Pl;
		U1 = Ul;
		R1 = Rl;
		P2 = Pr;
		U2 = Ur;
		R2 = Rr;
	}
	else
	{
		bInvert = true;
		P2 = Pl;
		U2 = -Ul;
		R2 = Rl;
		P1 = Pr;
		U1 = -Ur;
		R1 = Rr;
	}

	FFp(P2,P1,R1, &Ushock, &Oa);
	FFp(P1,P2,R2, &Urare,  &Oa);

	Uvac = -(sqrt(G*P1/R1) + sqrt(G*P2/R2))/G2;
// - - - - - - - - - - - - Left Right P00 - - - - - - - - - - - - - - - -
	Oa = U1-U2;
	if (Oa >= Ushock)
	{
		Left = 'S';
		Right = 'S';
		P00 = P2;
	}
	else
	{
		if (Oa >= Urare)
		{
			Left = 'S';
			Right = 'R';
			P00 = P1;
		}
		else
		{
			if (Oa > Uvac)
			{
				Left = 'R';
				Right = 'R';
				P00 = P1*0.1;
			}
			else
			{
				Left = 'V';
				Right = 'V';
				(*Pc) = P0; // P0  
				(*Rc) = R0; // R0 
				(*Uc) = fabs(Uvac);
				*iter = 0;
				goto Mend;
			}
		}
	}
// - - - - - - - - - - - - - - - - Pc - - - - - - - - - - - - - - - - -
	Oz = 1.;
	*iter = 0;
M10:;	*iter++;

	if (*iter>100)
	{
		s.Format("  Riemann: iter = %i\nPc = %g P00 = %g\nP1 = %g "
			"R1 = %g\nP2 = %g R2 = %g\n Left,Right = ",
			*iter,*Pc,P00,P1,R1,P2,R2);
		s = s+Left;
		s = s+Right;
		s = s+"\n\n";
		Error += s;
//			break;
		goto M20;
	}

	FFp(P00,P1,R1, &Oa,&Ob);
	FFp(P00,P2,R2, &Oc,&Od);

	(*Pc) = P00 - (Oa + Oc - U1 + U2)/(Ob + Od);

	if ((*Pc) < 0.)
	{
		(*Pc) = fabs(P00)*0.1;
		Oz = 1.;
	}
	else Oz = fabs((P00 - (*Pc))/(*Pc));

	P00 = (*Pc);

	if (Oz>1e-6) goto M10;
// - - - - - - - - - - - - - - - Uc Rc - - - - - - - - - - - - - - - - -
M20:;	FFp((*Pc),P2,R2, Uc, &Oa);
	(*Uc) = U2 + (*Uc);

if ((*Uc) >= 0.)
{
	if (Left == 'S')
	{
		Oz = U1-sqrt((G4*(*Pc) + G2*P1)/R1);

		if (Oz >= 0.)
		{
			(*Rc) = R1;
			(*Uc) = U1;
			(*Pc) = P1;
		}
		else (*Rc) = R1*(G6*P1 + (*Pc))/(G6*(*Pc) + P1);
	}
	else
	{
		Oc = sqrt(G*P1/R1);
		Oa = U1 - Oc;

		if (Oa >= 0.)
		{
			(*Rc) = R1;
			(*Uc) = U1;
			(*Pc) = P1;
		}
		else
		{
			Od = Oc+G2*(U1-(*Uc));
			Ob = (*Uc)-Od;
			(*Rc) = G*(*Pc)/(Od*Od);

			if (Ob > 0.)
			{
				Od = -U1;
				Rarefaction(P1,R1,Od, Pc,Rc,Uc);
				(*Uc) = -(*Uc);
			}
		}
	}
}
else
{
	if (Right == 'S')
	{
		Oz = U2 + sqrt((G4*(*Pc) + G2*P2)/R2);

		if (Oz <= 0.)
		{
			(*Rc) = R2;
			(*Uc) = U2;
			(*Pc) = P2;
		}
		else        (*Rc) = R2*(G6*P2 + (*Pc))/(G6*(*Pc)+P2);
	}
	else
	{
		Oc = sqrt(G*P2/R2);
		Oa = U2 + Oc;

		if (Oa <= 0.)
		{
			(*Rc) = R2;
			(*Uc) = U2;
			(*Pc) = P2;
		}
		else
		{
			Od = Oc-G2*(U2 - (*Uc));
			Ob = (*Uc) + Od;
			(*Rc) = G*(*Pc)/(Od*Od);

			if (Ob<0.) Rarefaction(P2,R2,U2, Pc,Rc,Uc);

		}
	}
}

Mend:;
      if (bInvert)
	  {
         (*Uc) = -(*Uc);
         char Ch = Left;
         Left = Right;
         Right = Ch;
      }
}
//---------------------------------------------------------------------------
